local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")
local Loc = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Localisation")
local _ARTG = _Avyr_Raid_Tools_ADDON_Globals
local wipe, insert, remove = table.wipe, table.insert, table.remove
local BorderSize, Padding = Widgets.BorderSize, Widgets.Padding;


local ExpandedTabSelectDataSource = {}
local Menu = {}
_ARTG.OptionsMenu = Menu

local QuickWindow
local Window

Menu.QuickCall = function(self,Force)
	if QuickWindow and not QuickWindow.Released and Force ~= "Open" then
		QuickWindow:Release()
		QuickWindow = nil;
		_ARTG.OpenMenu = nil
	elseif not QuickWindow and Force ~= "Close" then 
		_ARTG.OptionsMenu:Call("Close");
		_ARTG.Editor:Call("Close")

		QuickWindow = Widgets:CreateWindow(UIParent, "Avyr Raid Tools")
		QuickWindow.OnCloseFunc = function() QuickWindow = nil end
		QuickWindow:Size(2*BorderSize + 3*Padding + 400, 2*BorderSize + 4*Padding + 150 + QuickWindow.Header:GetHeight())
		QuickWindow:MakeMovable(true)
		QuickWindow:SetPoint("CENTER")

		QuickWindow.OptionsButton = Widgets:CreateButton(QuickWindow)
		QuickWindow.OptionsButton:Size(200, 100)
		QuickWindow.OptionsButton:SetPoint("TOPLEFT", QuickWindow.Header, "BOTTOMLEFT", 0, -Widgets.Padding)
		QuickWindow.OptionsButton:SetText(Loc:Translation("DISPLAY_OPTIONS"),15,"Highlight")
		QuickWindow.OptionsButton.OnClick = function()
			Menu:Call("Open")
		end 
		
		QuickWindow.EditorButton = Widgets:CreateButton(QuickWindow)
		QuickWindow.EditorButton:Size(200, 100)
		QuickWindow.EditorButton:SetPoint("TOPLEFT", QuickWindow.OptionsButton, "TOPRIGHT", Widgets.Padding,0)
		QuickWindow.EditorButton:SetText(Loc:Translation("NOTE_EDITOR"),15,"Highlight")
		QuickWindow.EditorButton.OnClick = function()
			_ARTG.Editor:Call("Open")
		end 

		QuickWindow.SaveButton = Widgets:CreateButton(QuickWindow)
		QuickWindow.SaveButton:Size(200, 50)
		QuickWindow.SaveButton:SetPoint("TOPLEFT", QuickWindow.OptionsButton, "BOTTOMLEFT", 0, -Widgets.Padding)
		QuickWindow.SaveButton:SetText(Loc:Translation("SAVE_LOADED_NOTE"),15,"Highlight")
		QuickWindow.SaveButton:SetDisable(not _ARTG.SV.GetVariable("CurrentNote")["Name"]) 
		QuickWindow.SaveButton.OnClick = function()
			_ARTG.Editor:Call("Open")
			_ARTG.Editor:NoteInfoEdit(_ARTG.SV.GetVariable("CurrentNote").Name,_ARTG.SV.GetVariable("CurrentNote").Description,
			_ARTG.SV.GetVariable("CurrentNote").Expansion,_ARTG.SV.GetVariable("CurrentNote").Raid,_ARTG.SV.GetVariable("CurrentNote").Boss,
			function(Name,Description,Expansion,Raid,Boss)
				local DataClone = {}
				if _ARTG.SV.GetVariable("CurrentNote").Data then 
					for i,v in ipairs(_ARTG.SV.GetVariable("CurrentNote").Data) do 
						insert(DataClone,{v[1],v[2]})
					end 
				else 
					DataClone = nil
				end 
				_ARTG.Editor:EditNote("New",Name,Description,DataClone,Expansion,Raid,Boss)
			end)
		end 

		QuickWindow.ClearButton = Widgets:CreateButton(QuickWindow)
		QuickWindow.ClearButton:Size(200, 50)
		QuickWindow.ClearButton:SetPoint("TOPLEFT", QuickWindow.SaveButton, "TOPRIGHT", Widgets.Padding,0)
		QuickWindow.ClearButton:SetText(Loc:Translation("CLEAR_LOADED_NOTE"),15,"Highlight")
		QuickWindow.ClearButton:SetDisable(not _ARTG.SV.GetVariable("CurrentNote")["Name"]) 
		QuickWindow.ClearButton.OnClick = function()
			_ARTG.SV.SaveVariable("CurrentNote",{})
		end 
		_ARTG.OpenMenu = "QuickSelect"
	end 
end 

local SelectedOptionsTab = nil
local TabWidth = 200
local ContentWidth = 300

local OptionsTabs = {
	{Loc:Translation("OVERVIEW"),"GENERAL_OVERVIEW",Loc:Translation("GENERAL")},
	{Loc:Translation("COMPONENTS"),"GENERAL_COMPONENTS",Loc:Translation("GENERAL")},
	{Loc:Translation("SETTINGS"),"GENERAL_SETTINGS",Loc:Translation("GENERAL")},
	{Loc:Translation("PARTY_DATA"),"INTERNALDATA_SETTINGS",Loc:Translation("GENERAL")},
	
	{Loc:Translation("SETTINGS"),"DISPLAY_SETTINGS",Loc:Translation("NOTE_DISPLAY")},
	{Loc:Translation("GENERAL"),"DISPLAY_KEYWORDS_GENERAL",Loc:Translation("NOTE_DISPLAY"),Loc:Translation("KEYWORDS")},
	{Loc:Translation("LIST_OF_KEYWORDS"),"DISPLAY_KEYWORDS_KEYWORDS",Loc:Translation("NOTE_DISPLAY"),Loc:Translation("KEYWORDS")},
	{Loc:Translation("LIST_OF_COOLDOWNS"),"DISPLAY_KEYWORDS_CDS",Loc:Translation("NOTE_DISPLAY"),Loc:Translation("KEYWORDS")},
	{Loc:Translation("LOAD_CONDITIONS"),"DISPLAY_LOAD",Loc:Translation("NOTE_DISPLAY")},
	
	{Loc:Translation("SETTINGS"),"INFODISPLAY_SETTINGS",Loc:Translation("INFORMATION_DISPLAY")},
	{Loc:Translation("SEGMENTS"),"INFODISPLAY_COMPONENTS",Loc:Translation("INFORMATION_DISPLAY")},
	{Loc:Translation("LOAD_CONDITIONS"),"INFODISPLAY_LOAD",Loc:Translation("INFORMATION_DISPLAY")},

	{Loc:Translation("SETTINGS"),"HEALERMANA_SETTINGS",Loc:Translation("HEALER_MANA_DISPLAY")},
	{Loc:Translation("ADVANCED_AND_COLOR_OPTIONNAME"),"HEALERMANA_ADVANCED",Loc:Translation("HEALER_MANA_DISPLAY")},
	{Loc:Translation("LOAD_CONDITIONS"),"HEALERMANA_LOAD",Loc:Translation("HEALER_MANA_DISPLAY")},
	
	--{Loc:Translation("SETTINGS"),"CDDISPLAY_SETTINGS",Loc:Translation("COOLDOWN_DISPLAY")},
	--{Loc:Translation("LIST"),"CDDISPLAY_LIST",Loc:Translation("COOLDOWN_DISPLAY")},
	--{Loc:Translation("LOAD_CONDITIONS"),"CDDISPLAY_LOAD",Loc:Translation("COOLDOWN_DISPLAY")},
	
	--{Loc:Translation("SETTINGS"),"ENCOUNTERRECAP_SETTINGS",Loc:Translation("ENCOUNTER_RECAP")},
}

Menu.Call = function(self,Force)
	if Window and not Window.Released and Force ~= "Open" then
		Window:Release()
		Window = nil;
		_ARTG.NoteDisplay:Stop(true)
		_ARTG.OpenMenu = nil
	elseif not Window and Force ~= "Close" then 
		_ARTG.Editor:Call("Close")
		_ARTG.OptionsMenu:QuickCall("Close");
		--_ARTG.NoteDisplay:Start(true)

		Window = Widgets:CreateWindow(UIParent, "Avyr Raid Tools")
		Window.OnCloseFunc = function() 
			Window = nil
			_ARTG.NoteDisplay:Stop(true) 
		end
		Window:Size(TabWidth + ContentWidth + 2*BorderSize + 3*Padding, 500)
		Window.OnMove = function(self)
			local _, _, _, x, y = self:GetPoint(1)
			_ARTG.SV.SaveVariable("GM_PosX", x*Window:GetEffectiveScale(), true)
			_ARTG.SV.SaveVariable("GM_PosY", y*Window:GetEffectiveScale())
		end

		Menu:UpdateDimensions()

		Window.MenuTabSelect = Widgets:CreateSectionSelect(Window)
		Window.MenuTabSelect:Size(200,Window:GetHeight() - Window.Header:GetHeight() - 3*Padding - 2*BorderSize)
		Window.MenuTabSelect.ExpandedCategories = ExpandedTabSelectDataSource
		Window.MenuTabSelect:SetPoint("TOPLEFT",Window.Header,"BOTTOMLEFT",0,-Padding)
		for i,v in ipairs(OptionsTabs) do 
			Window.MenuTabSelect:AddItem(v[1],v[2],false,select(3,unpack(v)))
			if v[2] == SelectedOptionsTab then 
				Window.MenuTabSelect:SetSelect("Key",SelectedOptionsTab,select(3,unpack(v)))
			end 
		end 
		Window.MenuTabSelect:Refresh()
		Window.MenuTabSelect.OnSelect = function(Name,Key)
			Menu:Refresh(Key)
		end

		Window.MenuBlock = Widgets:CreateContainer(Window)
		Window.MenuBlock:SetPoint("BOTTOMLEFT",Window.MenuTabSelect,"BOTTOMRIGHT",Padding,0)
		Window.MenuBlock:Size(ContentWidth ,Window:GetHeight() - Window.Header:GetHeight() - 3*Padding - 2*BorderSize)

		Menu:Refresh(SelectedOptionsTab)
		_ARTG.OpenMenu = "Menu"
	end 
end 

Menu.UpdateDimensions = function(self)
	if Window then 
		Window:SetScale(_ARTG.SV.GetVariable("GM_Scale") or Window:GetScale())
		local Scale = Window:GetEffectiveScale()
		Window:SetPoint("CENTER",(_ARTG.SV.GetVariable("GM_PosX") or 0)/Scale,(_ARTG.SV.GetVariable("GM_PosY") or 0)/Scale)
		Window:MakeMovable(not _ARTG.SV.GetVariable("GM_Locked"))
	end 
end 


local NI_AnchorFrames = {
	{
		"UIParent",
		"NOTEDISPLAY",
		"INFODISPLAY",
		"HEALERMANADISPLAY",
		--"CDDISPLAY",
	},
	{
		Loc:Translation("UIPARENT"),
		Loc:Translation("NOTE_DISPLAY"),
		Loc:Translation("INFORMATION_DISPLAY"),
		Loc:Translation("HEALER_MANA_DISPLAY"),
		--Loc:Translation("COOLDOWN_DISPLAY")
	}
}

local function CallKeywordPopup(BoO,Type,Action,...)
	if Type == "Keyword" then 
		if BoO.ConnectedPopup then 
			BoO.ConnectedPopup:Release();
			BoO.ConnectedPopup = nil;
		else 
			local i,newKeyword,CaseMatch,OverrideSound 
			if Action == "Edit" then 
				i,newKeyword,CaseMatch,OverrideSound = ...
				BoO.ConnectedPopup = Widgets:CallPopup(BoO,Loc:Translation("EDIT_KEYWORD"))
			else 
				BoO.ConnectedPopup = Widgets:CallPopup(BoO,Loc:Translation("NEW_KEYWORD"))
			end

			BoO.ConnectedPopup:AddRow("Type","TB","Text",Loc:Translation("KEYWORD"),"Value",newKeyword,"Func",function(_,value)
				newKeyword = value;
			end)
			BoO.ConnectedPopup:AddRow("Type","CB","Text",Loc:Translation("CASE_MATCH"),"Value",CaseMatch,"Func",function(_,checked)
				CaseMatch = checked
			end)
			BoO.ConnectedPopup:AddRow("Type","SB","Value",_ARTG.DataFuncs.Sounds("sound.get.byId.name",OverrideSound),"Name","SoundSelectItem","Text",Loc:Translation("OVERRIDE_SOUND"),
			"Options",_ARTG.DataFuncs.Sounds("list.get")[1],"Func",function(self,Value, Index)  
				local soundId = _ARTG.DataFuncs.Sounds("sound.get.byIndex.id",Index,Value)
				_ARTG.DataFuncs.Sounds("sound.play",soundId)
				OverrideSound = soundId
			end)
			BoO.ConnectedPopup:AddRow("Type","DB","Text",Loc:Translation("CLEAR_SOUND"),"Func",function()           
				OverrideSound = nil
				BoO.ConnectedPopup:ChangeItem("SoundSelectItem","Value",nil)
			end)
			if Action == "Edit" then 
				BoO.ConnectedPopup:AddRow("Type","DB","Text",Loc:Translation("SAVE_CHANGES"),"Func",function()           
					if newKeyword and newKeyword ~= "" then 
						_ARTG.SV:EditMyCooldownKeyword("Keyword","Edit",i,"Term",newKeyword)
						_ARTG.SV:EditMyCooldownKeyword("Keyword","Edit",i,"CM",CaseMatch)
						_ARTG.SV:EditMyCooldownKeyword("Keyword","Edit",i,"Sound",OverrideSound)
					else
						print("ART: " .. Loc:Translation("INVALID_INPUT_FULLSTOP"))
					end
				end)
			else 
				BoO.ConnectedPopup:AddRow("Type","DB","Text",Loc:Translation("SAVE"),"Func",function()           
					if newKeyword and newKeyword ~= "" then 
						if _ARTG.SV:IsCooldownKeyword("Keyword",newKeyword) then 
							BoO.ConnectedPopup:Release()
							BoO.ConnectedPopup = nil
							print("ART: " .. Loc:Translation("KEYWORD_%KEYWORD_ALREADY_EXISTS_FULLSTOP"):format(newKeyword))
						else 
							BoO.ConnectedPopup:Release()
							BoO.ConnectedPopup = nil
							_ARTG.SV:AddMyCooldownKeyword("Keyword",newKeyword,CaseMatch,OverrideSound)
						end 
					else
						print("ART: " .. Loc:Translation("INVALID_INPUT_FULLSTOP"))
					end
				end)
			end
		end 
	elseif Type == "CD" then
		if BoO.ConnectedPopup then 
			BoO.ConnectedPopup:Release();
			BoO.ConnectedPopup = nil;
		else 
			local i,Cooldown,PlayerName,CaseMatch,OverrideSound 
			local DisplayString = ""
			if Action == "Edit" then 
				local index,Term,CM,Sound = ...
				CaseMatch = CM
				OverrideSound = Sound
				i = index
				DisplayString,Cooldown,PlayerName = _ARTG.SV.NoteEntry("CD","Display",Term)
				BoO.ConnectedPopup = Widgets:CallPopup(BoO,Loc:Translation("EDIT_COOLDOWN"))
			else
				BoO.ConnectedPopup = Widgets:CallPopup(BoO,Loc:Translation("NEW_COOLDOWN"))
			end

			BoO.ConnectedPopup:AddRow("Type","TB","Text",Loc:Translation("SPELLID_OR_SPELLNAME"),"Tooltip",Loc:Translation("SPELL_NAMES_ONLY_WORK_FOR_SPELLS_IN_SPELLBOOK"),"Value",Cooldown,
			"Name","SpellIDInput_TB","Func",function(_,value)
				local SpellID = tonumber(value) 
				if not SpellID then 
					SpellID = GetSpellInfo(value)
				end
				if SpellID and GetSpellInfo(SpellID) then 
					Cooldown = SpellID
					local DisplayString = _ARTG.SV.NoteEntry("CD","Display",_ARTG.SV.NoteEntry("CD","Create",Cooldown,PlayerName))
					BoO.ConnectedPopup:ChangeItem("SpellIDDisplay_LB","Text",DisplayString)
				else 
					print("ART: " .. Loc:Translation("UNKNWON_SPELL_FULLSTOP"))
					BoO.ConnectedPopup:ChangeItem("SpellIDInput_TB","Value",Cooldown)
				end 
			end)
			BoO.ConnectedPopup:AddRow("Type","LB","Text",DisplayString,"Name","SpellIDDisplay_LB")
			BoO.ConnectedPopup:AddRow("Type","TB","Text",Loc:Translation("PLAYER_NAME"),"Value",PlayerName,"Func",function(_,value)
				PlayerName = value
				local DisplayString = _ARTG.SV.NoteEntry("CD","Display",_ARTG.SV.NoteEntry("CD","Create",Cooldown,PlayerName))
				BoO.ConnectedPopup:ChangeItem("SpellIDDisplay_LB","Text",DisplayString)
			end)
			BoO.ConnectedPopup:AddRow("Type","CB","Text",Loc:Translation("CASE_MATCH"),"Value",CaseMatch,"Func",function(_,checked)
				CaseMatch = checked
			end)
			BoO.ConnectedPopup:AddRow("Type","SB","Value",_ARTG.DataFuncs.Sounds("sound.get.byId.name",OverrideSound),"Name","SoundSelectItem","Text",Loc:Translation("OVERRIDE_SOUND"),
			"Options",_ARTG.DataFuncs.Sounds("list.get")[1],"Func",function(self,Value, Index)  
				local soundId = _ARTG.DataFuncs.Sounds("sound.get.byIndex.id",Index,Value)
				_ARTG.DataFuncs.Sounds("sound.play",soundId)
				OverrideSound = soundId
			end)
			BoO.ConnectedPopup:AddRow("Type","DB","Text",Loc:Translation("CLEAR_SOUND"),"Func",function()           
				OverrideSound = nil
				BoO.ConnectedPopup:ChangeItem("SoundSelectItem","Value",nil)
			end)
			if Action == "Edit" then 
				BoO.ConnectedPopup:AddRow("Type","DB","Text",Loc:Translation("SAVE_CHANGES"),"Func",function()           
					if Cooldown and GetSpellInfo(Cooldown) then 
						local CDString = _ARTG.SV.NoteEntry("CD","Create",Cooldown,PlayerName)
						_ARTG.SV:EditMyCooldownKeyword("CD","Edit",i,"Term",CDString)
						_ARTG.SV:EditMyCooldownKeyword("CD","Edit",i,"CM",CaseMatch)
						_ARTG.SV:EditMyCooldownKeyword("CD","Edit",i,"Sound",OverrideSound)
					else
						print("ART: " .. Loc:Translation("INVALID_INPUT_FULLSTOP"))
					end
				end)
			else 
				BoO.ConnectedPopup:AddRow("Type","DB","Text",Loc:Translation("SAVE"),"Func",function()           
					if Cooldown and GetSpellInfo(Cooldown) then 
						local CDString = _ARTG.SV.NoteEntry("CD","Create",Cooldown,PlayerName)
						if _ARTG.SV:IsCooldownKeyword("CD",CDString) then 
							BoO.ConnectedPopup:Release()
							BoO.ConnectedPopup = nil
							print("ART: " .. Loc:Translation("COOLDOWN_%COOLDOWN_ALREADY_EXISTS"):format(_ARTG.SV.NoteEntry("CD","Display",CDString)))
						else 
							BoO.ConnectedPopup:Release()
							BoO.ConnectedPopup = nil
							_ARTG.SV:AddMyCooldownKeyword("CD",Cooldown,PlayerName,CaseMatch,OverrideSound)
						end 
					else
						print("ART: " .. Loc:Translation("INVALID_INPUT_FULLSTOP"))
					end
				end)
			end
		end 
	end 
end 

Menu.Refresh = function(self, SelectedTab, RefreshOnly)
	if RefreshOnly and SelectedOptionsTab ~= SelectedTab then 
		return nil
	end 
	if Window then 
		SelectedOptionsTab = SelectedTab or SelectedOptionsTab
		Window.MenuBlock:ClearItems()
		if SelectedOptionsTab then 
			if SelectedOptionsTab == "GENERAL_OVERVIEW" then 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ENABLE ADDON"),"Value",_ARTG.SV.GetVariable("G_Enable"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("G_Enable",value)
				end)

				Window.MenuBlock:AddRow("Type","DB","Text",Loc:Translation("RESTORE_DEFAULT_SETTINGS"),"Func",function()
					Widgets:VerifyAction(UIParent, Loc:Translation("OVERWRITE_ALL_SETTINGS"), Loc:Translation("PERMA_DELETE_WARNING"), function()
						_ARTG.SV.ResetSettings()
					end)   
				end)
			elseif SelectedOptionsTab == "GENERAL_COMPONENTS" then
				Window.MenuBlock:AddRow("Header",Loc:Translation("MINIMAP_ICON"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ENABLE"),"Value",_ARTG.SV.GetVariable("MI_Enable"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("MI_Enable",value)
				end,
				"Type","DB","Text",Loc:Translation("RESET_POSITION"),"Func", function()
					_ARTG.SV.SaveVariable("MI_PosX",0,true)
					_ARTG.SV.SaveVariable("MI_PosY",0)          
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("NOTE_EDITOR"))
				Window.MenuBlock:AddRow("Type","DB","Text",Loc:Translation("RESET"),"Func",function()
					_ARTG.SV.SaveVariable("NE_PosX",0,true)
					_ARTG.SV.SaveVariable("NE_PosY",0,true)
					_ARTG.SV.SaveVariable("NE_Scale",1,true)
					_ARTG.SV.SaveVariable("NE_FullScreen",false)  
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("NOTE_DISPLAY"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ENABLE"),"Value",_ARTG.SV.GetVariable("ND_Enable"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_Enable",value)
				end)
			elseif SelectedOptionsTab == "GENERAL_SETTINGS" then
				Window.MenuBlock:AddRow("Header",Loc:Translation("DIMENSIONS"))
				Window.MenuBlock:AddRow("Type","NB","Text",Loc:Translation("SCALE"),"Value",_ARTG.SV.GetVariable("GM_Scale"),"Min",0.5,"Step",0.01,"Max",2,
				"IgnoreSlideUpdates",true,"Func",function(self, value)
					_ARTG.SV.SaveVariable("GM_Scale",value)
				end)
				Window.MenuBlock:AddRow("Type","DB","Text",Loc:Translation("RESET_POSITION"),"Func",function()
					_ARTG.SV.SaveVariable("GM_PosX",0,true)
					_ARTG.SV.SaveVariable("GM_PosY",0,true)
					_ARTG.SV.SaveVariable("GM_Scale",1)
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("OPTIONS_THEME"))
				Window.MenuBlock:AddRow("Type","CP","Text",Loc:Translation("NORMAL_COLOR"),"r",Widgets.NormalColor.r,"g",Widgets.NormalColor.g,
				"b",Widgets.NormalColor.b,"a",1,"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("G_NormalColorr",r, true)
					_ARTG.SV.SaveVariable("G_NormalColorg",g, true)
					_ARTG.SV.SaveVariable("G_NormalColorb",b)
				end,
				"Type","CP","Text",Loc:Translation("HIGHLIGHT_COLOR"),"r",Widgets.HighlightColor.r,"g",Widgets.HighlightColor.g,
				"b",Widgets.HighlightColor.b,"a",1,"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("G_HighlightColorr",r, true)
					_ARTG.SV.SaveVariable("G_HighlightColorg",g, true)
					_ARTG.SV.SaveVariable("G_HighlightColorb",b)
				end)

				Window.MenuBlock:AddRow("Type","CP","Text",Loc:Translation("BORDER_COLOR"),"r",Widgets.BorderColor.r,"g",Widgets.BorderColor.g,
				"b",Widgets.BorderColor.b,"a",Widgets.BorderColor.a,"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("G_BorderColorr",r, true)
					_ARTG.SV.SaveVariable("G_BorderColorg",g, true)
					_ARTG.SV.SaveVariable("G_BorderColorb",b,true)
					_ARTG.SV.SaveVariable("G_BorderColora",a)
				end,
				"Type","CP","Text",Loc:Translation("BACKDROP_COLOR"),"r",Widgets.BackdropColor.r,"g",Widgets.BackdropColor.g,
				"b",Widgets.BackdropColor.b,"a",Widgets.BackdropColor.a,"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("G_BackdropColorr",r, true)
					_ARTG.SV.SaveVariable("G_BackdropColorg",g, true)
					_ARTG.SV.SaveVariable("G_BackdropColorb",b,true)
					_ARTG.SV.SaveVariable("G_BackdropColora",a)
				end)
				Window.MenuBlock:AddRow("Type","DB","Text",Loc:Translation("RESTORE_DEFAULT_THEME"),"Func",function()
					_ARTG.SV.SaveVariable("G_NormalColorr",nil, true)
					_ARTG.SV.SaveVariable("G_NormalColorg",nil, true)
					_ARTG.SV.SaveVariable("G_NormalColorb",nil, true)
					_ARTG.SV.SaveVariable("G_HighlightColorr",nil, true)
					_ARTG.SV.SaveVariable("G_HighlightColorg",nil, true)
					_ARTG.SV.SaveVariable("G_HighlightColorb",nil, true)
					_ARTG.SV.SaveVariable("G_BorderColorr",nil, true)
					_ARTG.SV.SaveVariable("G_BorderColorg",nil, true)
					_ARTG.SV.SaveVariable("G_BorderColorb",nil, true)
					_ARTG.SV.SaveVariable("G_BorderColora",nil, true)
					_ARTG.SV.SaveVariable("G_BackdropColorr",nil, true)
					_ARTG.SV.SaveVariable("G_BackdropColorg",nil, true)
					_ARTG.SV.SaveVariable("G_BackdropColorb",nil, true)
					_ARTG.SV.SaveVariable("G_BackdropColora",nil, true)
					Widgets:DefaultTheme()
				end)
			elseif SelectedOptionsTab == "INTERNALDATA_SETTINGS" then 
				 Window.MenuBlock:AddRow("Type","LB","Text",Loc:Translation("INTERNAL_DATA_SETS_STRING"))     
				 Window.MenuBlock:AddRow("Type","LB","Text",Loc:Translation("NAME"),
					 "Type","LB","Text",Loc:Translation("UNITID"),
					 "Type","LB","Text",Loc:Translation("GUID"),
					 "Type","LB","Text",Loc:Translation("ROLE")
				 )               
				 for i,v in pairs(_ARTG.Data.InspectPlayerData) do 
					  Window.MenuBlock:AddRow("Type","LB","Text",UnitName(v.UnitID),
						 "Type","LB","Text",v.UnitID,
						 "Type","LB","Text",i,
						 "Type","LB","Text",v.Role
					  )                     
				 end
			elseif SelectedOptionsTab == "DISPLAY_SETTINGS" then 
				--Window.MenuBlock:AddRow("Type","LB","Text",Loc:Translation("THEME"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("LOCK_POSITION"),"Value",_ARTG.SV.GetVariable("ND_Locked"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_Locked",value)
				end,
				"Type","DB","Text",Loc:Translation("RESET_POSITION"),"Func",function()
					_ARTG.SV.SaveVariable("ND_PosX",0,true)
					_ARTG.SV.SaveVariable("ND_PosY",0)
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("DIMENSIONS"))
				Window.MenuBlock:AddRow("Type","NB","Text",Loc:Translation("SCALE"),"Min",0.5,"Step",0.01,"Max",2,"Value",_ARTG.SV.GetVariable("ND_Scale"),"Func",function(self, value)
					_ARTG.SV.SaveVariable("ND_Scale",value)
				end)

				Window.MenuBlock:AddRow("Type","NB","Text",Loc:Translation("HEIGHT"),"Min",100,"Step",10,"Max",450,"Value",_ARTG.SV.GetVariable("ND_Height"),"Func",function(self, value)
					_ARTG.SV.SaveVariable("ND_Height",value)
				end,
				"Type","NB","Text",Loc:Translation("WIDTH"),"Min",150,"Step",10,"Max",450,"Value",_ARTG.SV.GetVariable("ND_Width"),"Func",function(self, value)
					_ARTG.SV.SaveVariable("ND_Width",value)
				end)

				Window.MenuBlock:AddRow("Type","DB","Text",Loc:Translation("RESET_DIMENSIONS"),"Func",function()
					_ARTG.SV.SaveVariable("ND_Scale",1)
					_ARTG.SV.SaveVariable("ND_Height",290,true)
					_ARTG.SV.SaveVariable("ND_Width",220)
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("FONT_COLOR"))
				Window.MenuBlock:AddRow("Type","CP","Text",Loc:Translation("CONDITION"),"r",_ARTG.SV.GetVariable("ND_ConditionFontr"),
				"g",_ARTG.SV.GetVariable("ND_ConditionFontg"),"b",_ARTG.SV.GetVariable("ND_ConditionFontb"),"a",_ARTG.SV.GetVariable("ND_ConditionFonta"),
				"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("ND_ConditionFontr",r, true)
					_ARTG.SV.SaveVariable("ND_ConditionFontg",g, true)
					_ARTG.SV.SaveVariable("ND_ConditionFontb",b, true)
					_ARTG.SV.SaveVariable("ND_ConditionFonta",a)
				end,
				"Type","CP","Text",Loc:Translation("NOTE"),"r",_ARTG.SV.GetVariable("ND_NoteFontr"),
				"g",_ARTG.SV.GetVariable("ND_NoteFontg"),"b",_ARTG.SV.GetVariable("ND_NoteFontb"),"a",_ARTG.SV.GetVariable("ND_NoteFonta"),
				"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("ND_NoteFontr",r, true)
					_ARTG.SV.SaveVariable("ND_NoteFontg",g, true)
					_ARTG.SV.SaveVariable("ND_NoteFontb",b, true)
					_ARTG.SV.SaveVariable("ND_NoteFonta",a)
				end)
				
				Window.MenuBlock:AddRow("Header",Loc:Translation("BACKGROUND_COLOR"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("BACKDROP"),"Value",_ARTG.SV.GetVariable("ND_Backdrop"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_Backdrop",value)
				end,
				"Type","CP","r",_ARTG.SV.GetVariable("ND_Backdropr"),"g",_ARTG.SV.GetVariable("ND_Backdropg"),"b",_ARTG.SV.GetVariable("ND_Backdropb"),
				"a",_ARTG.SV.GetVariable("ND_Backdropa"),"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("ND_Backdropr",r, true)
					_ARTG.SV.SaveVariable("ND_Backdropg",g, true)
					_ARTG.SV.SaveVariable("ND_Backdropb",b, true)
					_ARTG.SV.SaveVariable("ND_Backdropa",a)
				end,"FixedWidth",20)

				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("HIGHLIGHT_CURRENT_ENTRY"),"Value",_ARTG.SV.GetVariable("ND_HighlightCurrent"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_HighlightCurrent",value)
				end,
				"Type","CP","r",_ARTG.SV.GetVariable("ND_HighlightCurrentr"),"g",_ARTG.SV.GetVariable("ND_HighlightCurrentg"),"b",_ARTG.SV.GetVariable("ND_HighlightCurrentb"),
				"a",_ARTG.SV.GetVariable("ND_HighlightCurrenta"),"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("ND_HighlightCurrentr",r, true)
					_ARTG.SV.SaveVariable("ND_HighlightCurrentg",g, true)
					_ARTG.SV.SaveVariable("ND_HighlightCurrentb",b, true)
					_ARTG.SV.SaveVariable("ND_HighlightCurrenta",a)
				end,"FixedWidth",20)
				
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("HIGHLIGHT_UPCOMING_ENTRY"),"Value",_ARTG.SV.GetVariable("ND_HighlightNext"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_HighlightNext",value)
				end,
				"Type","CP","r",_ARTG.SV.GetVariable("ND_HighlightNextr"),"g",_ARTG.SV.GetVariable("ND_HighlightNextg"),"b",_ARTG.SV.GetVariable("ND_HighlightNextb"),
				"a",_ARTG.SV.GetVariable("ND_HighlightNexta"),"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("ND_HighlightNextr",r, true)
					_ARTG.SV.SaveVariable("ND_HighlightNextg",g, true)
					_ARTG.SV.SaveVariable("ND_HighlightNextb",b, true)
					_ARTG.SV.SaveVariable("ND_HighlightNexta",a)
				end,"FixedWidth",20)

				Window.MenuBlock:AddRow("Header",Loc:Translation("TRANSITION"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("SMOOTH_TRANSITION_BETWEEN_ENTRIES"),"Value",_ARTG.SV.GetVariable("ND_SmoothScroll"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_SmoothScroll",value)
				end)
				Window.MenuBlock:AddRow("Type","NB","Text",Loc:Translation("TRANSITION_TIME"),"Min",0.1,"Step",0.1,"Max",2,
				"Value",_ARTG.SV.GetVariable("ND_TransitionTime"),"Func",function(self, value)
					_ARTG.SV.SaveVariable("ND_TransitionTime",value)
				end)
			elseif SelectedOptionsTab == "DISPLAY_KEYWORDS_GENERAL" then 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("HIGHLIGHT_ENTRIES_WITH_KEYWORDS"),"Value",_ARTG.SV.GetVariable("ND_EnableKeywords"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_EnableKeywords",value)
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("HIGHLIGHT_KEYWORDS"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("BORDER_COLOR"),"Value",_ARTG.SV.GetVariable("ND_KeywordsBorderHighlight"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_KeywordsBorderHighlight",value)
				end,
				"Type","CP","r",_ARTG.SV.GetVariable("ND_KeywordsBorderHighlightr"),"g",_ARTG.SV.GetVariable("ND_KeywordsBorderHighlightg"),
				"b",_ARTG.SV.GetVariable("ND_KeywordsBorderHighlightb"),"a",_ARTG.SV.GetVariable("ND_KeywordsBorderHighlighta"),"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("ND_KeywordsBorderHighlightr",r, true)
					_ARTG.SV.SaveVariable("ND_KeywordsBorderHighlightg",g, true)
					_ARTG.SV.SaveVariable("ND_KeywordsBorderHighlightb",b, true)
					_ARTG.SV.SaveVariable("ND_KeywordsBorderHighlighta",a)
				end,"FixedWidth",20)

				Window.MenuBlock:AddRow("Header",Loc:Translation("SOUND"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("PLAY_SOUND"),"Value",_ARTG.SV.GetVariable("ND_EnableSound"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_EnableSound",value)
				end,
				"Type","SB","Value",_ARTG.DataFuncs.Sounds("sound.get.byId.name",_ARTG.SV.GetVariable("ND_BaseSound")),
				"Options",_ARTG.DataFuncs.Sounds("list.get")[1],"Func",function(self,Value, Index)  
					local soundId = _ARTG.DataFuncs.Sounds("sound.get.byIndex.id",Index,Value)
					_ARTG.DataFuncs.Sounds("sound.play",soundId)
					_ARTG.SV.SaveVariable("ND_BaseSound",soundId)
				end)
			elseif SelectedOptionsTab == "DISPLAY_KEYWORDS_KEYWORDS" then 
				Window.MenuBlock:AddRow("Type","DB","Text",Loc:Translation("ADD_KEYWORD"),
				"Func",function(self)
					CallKeywordPopup(self,"Keyword","New")
				end)   
				for i,v in ipairs(AvyrRaidTools_DB.Keywords) do 
					if v.Term then 
						Window.MenuBlock:AddRow("Type","DB","Text",v.Term,"Alignment","Left",
						"Func",function(self,value)
							CallKeywordPopup(self,"Keyword","Edit",i,v.Term,v.CM,v.Sound)
						end,
						"Type","DB","CloseBtn",true,"FixedWidth",20,
						"Func",function(self)
							if self.ConnectedPopup then 
								self.ConnectedPopup:Release();
								self.ConnectedPopup = nil
							else 
								self.ConnectedPopup = Widgets:CallPopup(self,Loc:Translation("DELETE_QUESTION"))
								self.ConnectedPopup:AddRow("Type","LB","Text",Loc:Translation("CONFIRM_PERMA_DELETE_QUESTION"):format(v.Term))
								self.ConnectedPopup:AddRow("Type","DB","Text",Loc:Translation("DELETE"),
								"Func",function(_,value)
									_ARTG.SV:EditMyCooldownKeyword("Keyword","Remove",i)
								end,"Type","DB","Text",Loc:Translation("CANCEL"),"Func",function()
									self.ConnectedPopup:Release()
									self.ConnectedPopup = nil
								end)
							end
						end)     
					end 
				end 
			elseif SelectedOptionsTab == "DISPLAY_KEYWORDS_CDS" then 
					Window.MenuBlock:AddRow("Type","DB","Text",Loc:Translation("ADD_COOLDOWN"),
				"Func",function(self)
					CallKeywordPopup(self,"CD","New")
				end)   
				for i,v in ipairs(AvyrRaidTools_DB.KeywordsCD) do 
					if v.Term then 
						local DisplayString = _ARTG.SV.NoteEntry("CD","Display",v.Term)
						Window.MenuBlock:AddRow("Type","DB","Text",DisplayString,"Alignment","Left",
						"Func",function(self,value)
							CallKeywordPopup(self,"CD","Edit",i,v.Term,v.CM,v.Sound)
						end,
						"Type","DB","CloseBtn",true,"FixedWidth",20,
						"Func",function(self)
							if self.ConnectedPopup then 
								self.ConnectedPopup:Release();
								self.ConnectedPopup = nil
							else 
								self.ConnectedPopup = Widgets:CallPopup(self,Loc:Translation("DELETE_QUESTION"))
								self.ConnectedPopup:AddRow("Type","LB","Text",Loc:Translation("CONFIRM_PERMA_DELETE_COOLDOWN"))
								self.ConnectedPopup:AddRow("Type","LB","Text",DisplayString)
								self.ConnectedPopup:AddRow("Type","DB","Text",Loc:Translation("DELETE"),
								"Func",function(_,value)
									_ARTG.SV:EditMyCooldownKeyword("CD","Remove",i)
								end,"Type","DB","Text",Loc:Translation("CANCEL"),"Func",function()
									self.ConnectedPopup:Release()
									self.ConnectedPopup = nil
								end)
							end
						end)     
					end 
				end 
			elseif SelectedOptionsTab == "DISPLAY_LOAD" then 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ALWAYS"),"Value",_ARTG.SV.GetVariable("ND_AlwaysLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_AlwaysLoad",value)
				end)
				Window.MenuBlock:AddRow("Type","Line")
				Window.MenuBlock:AddRow("Type","LB","Text",Loc:Translation("LOAD_WHEN_IN_CONTINUED"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_A_RAID_GROUP"),"Value",_ARTG.SV.GetVariable("ND_RaidLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_RaidLoad",value)
				end)
					
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_A_RAID_INSTANCE"),"Value",_ARTG.SV.GetVariable("ND_RaidInLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_RaidInLoad",value)
				end)
					
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_GUILD_RAID_INSTANCE"),"Value",_ARTG.SV.GetVariable("ND_GuildRaidInLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_GuildRaidInLoad",value)
				end)    
				Window.MenuBlock:AddRow("Type","Line")
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("HIDE_IF_NO_NOTE_LOADED"),"Value",_ARTG.SV.GetVariable("ND_NoNoteHide"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ND_NoNoteHide",value)
				end)
			elseif SelectedOptionsTab == "INFODISPLAY_SETTINGS" then 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ENABLE"),"Value",_ARTG.SV.GetVariable("ID_Enable"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_Enable",value)
				end)

					
				Window.MenuBlock:AddRow("Header",Loc:Translation("POSITION"))
				local SelectedAnchorFrame = nil
				for i,v in ipairs(NI_AnchorFrames[1]) do 
					if v == _ARTG.SV.GetVariable("ID_Anchor") then 
						SelectedAnchorFrame = NI_AnchorFrames[2][i]
					end
				end 
				local SelectedAnchorPoint = nil
				for i,v in ipairs(_ARTG.Data.FrameAnchorPoints[1]) do 
					if v == _ARTG.SV.GetVariable("ID_AnchorPoint") then 
						SelectedAnchorPoint = _ARTG.Data.FrameAnchorPoints[2][i]
					end
				end 
				Window.MenuBlock:AddRow("Type","SB","Value",SelectedAnchorFrame,"Options",NI_AnchorFrames[2],"Func",function(self,Value, Index)  
					if NI_AnchorFrames[1][Index] then 
						_ARTG.SV.SaveVariable("ID_Anchor",NI_AnchorFrames[1][Index])
					end 
				end,"Type","SB","Value",SelectedAnchorPoint,"Options",_ARTG.Data.FrameAnchorPoints[2],"Func",function(self,Value, Index)  
					if _ARTG.Data.FrameAnchorPoints[1][Index] then 
						_ARTG.SV.SaveVariable("ID_AnchorPoint",_ARTG.Data.FrameAnchorPoints[1][Index])
					end 
				end) 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("LOCK_POSITION"),"Value",_ARTG.SV.GetVariable("ID_Locked"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_Locked",value)
				end,
				"Type","DB","Text",Loc:Translation("RESET_POSITION"),"Func",function()
					_ARTG.SV.SaveVariable("ID_PosX",0,true)
					_ARTG.SV.SaveVariable("ID_PosY",0)
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("DIMENSIONS"))
				Window.MenuBlock:AddRow("Type","NB","Text",Loc:Translation("SCALE"),"Value",_ARTG.SV.GetVariable("ID_Scale"),"Min",0.5,"Step",0.01,"Max",2,
				"Func",function(self, value)
					_ARTG.SV.SaveVariable("ID_Scale",value)
				end)
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("MATCH_WIDTH"),"Value",_ARTG.SV.GetVariable("ID_MatchWidth"),
				"Tooltip",Loc:Translation("MATCH_WIDTH_ATTACHED_DISPLAY"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_MatchWidth",value)
				end)
				Window.MenuBlock:AddRow("Type","NB","Text",Loc:Translation("WIDTH"),"Value",_ARTG.SV.GetVariable("ID_Width"),"Min",100,"Step",10,"Max",450,
				"Func",function(self, value)
					_ARTG.SV.SaveVariable("ID_Width",value)
				end,
				"Type","NB","Text",Loc:Translation("ROW_HEIGHT"),"Value",_ARTG.SV.GetVariable("ID_RowHeight"),"Min",5,"Step",5,"Max",100,
				"Func",function(self, value)
					_ARTG.SV.SaveVariable("ID_RowHeight",value)
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("BACKGROUND"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("MATCH_BACKGROUND"),"Value",_ARTG.SV.GetVariable("ID_MatchBackdrop"),
				"Tooltip",Loc:Translation("MATCH_BACKGROUND_ATTACHED_DISPLAY"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_MatchBackdrop",value)
				end)
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("BACKGROUND_COLOR"),"Value",_ARTG.SV.GetVariable("ID_Backdrop"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_Backdrop",value)
				end,
				"Type","CP","r",_ARTG.SV.GetVariable("ID_Backdropr"),"g",_ARTG.SV.GetVariable("ID_Backdropg"),
				"b",_ARTG.SV.GetVariable("ID_Backdropb"),"a",_ARTG.SV.GetVariable("ID_Backdropa"),"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("ID_Backdropr",r, true)
					_ARTG.SV.SaveVariable("ID_Backdropg",g, true)
					_ARTG.SV.SaveVariable("ID_Backdropb",b, true)
					_ARTG.SV.SaveVariable("ID_Backdropa",a)
				end,"FixedWidth",20)

			elseif SelectedOptionsTab == "INFODISPLAY_COMPONENTS" then 
				for i,v in ipairs(AvyrRaidTools_DB["ID_Data"]) do 
					if v:find("ET:") then 
						local Enable,r,g,b,a,Icon = _ARTG.SV.GetInformationDisplayItem("Unpack",v)
						Window.MenuBlock:AddRow("Header","Encounter timer")

						Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ENABLE"),"Value",Enable,"Func",function(_,value)
							_ARTG.SV.EditInformationDisplayItem("ET","Enable",value)
						end,
						"Type","LB","Text",Loc:Translation("SEGMENT_INDEX")..": "..i,"FixedHeight",20,
						"Type","DB","Icon",Widgets:GetIcon("ArrowHeadMask"),"FixedWidth",20,"IconData",{"Theme","Highlight","Rotation",135},"Func",function()
							_ARTG.SV.EditInformationDisplayItem("ET","Position",-1)
						end,
						"Type","DB","Icon",Widgets:GetIcon("ArrowHeadMask"),"FixedWidth",20,"IconData",{"Theme","Highlight","Rotation",315},"Func",function()
							_ARTG.SV.EditInformationDisplayItem("ET","Position",1)
						end
						)
						Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("SHOW_ICON"),"Value",Icon,"Func",function(_,value)
							_ARTG.SV.EditInformationDisplayItem("ET","Icon",value)
						end,
						"Type","CP","Text",Loc:Translation("FONT_COLOR"),"r",r,"g",g,"b",b,"a",a,"Func",
						function(_,r,g,b,a)
							_ARTG.SV.EditInformationDisplayItem("ET","Color",r,g,b,a)
						end)

					elseif v:find("CR:") then 
						local Enable,r,g,b,a,Icon,Timer,Count = _ARTG.SV.GetInformationDisplayItem("Unpack",v)

						Window.MenuBlock:AddRow("Header","Brez counter")
						Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ENABLE"),"Value",Enable,"Func",function(_,value)
							_ARTG.SV.EditInformationDisplayItem("CR","Enable",value)
						end,
						"Type","LB","Text",Loc:Translation("SEGMENT_INDEX")..": "..i,"FixedHeight",20,
						"Type","DB","Icon",Widgets:GetIcon("ArrowHeadMask"),"FixedWidth",20,"IconData",{"Theme","Highlight","Rotation",135},"Func",function()
							_ARTG.SV.EditInformationDisplayItem("CR","Position",-1)
						end,
						"Type","DB","Icon",Widgets:GetIcon("ArrowHeadMask"),"FixedWidth",20,"IconData",{"Theme","Highlight","Rotation",315},"Func",function()
							_ARTG.SV.EditInformationDisplayItem("CR","Position",1)
						end
						)
						Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("SHOW_ICON"),"Value",Icon,"Func",function(_,value)
							_ARTG.SV.EditInformationDisplayItem("CR","Icon",value)
						end,
						"Type","CB","Text",Loc:Translation("SHOW_COUNT"),"Value",Count,"Func",function(_,value)
							_ARTG.SV.EditInformationDisplayItem("CR","Count",value)
						end)
						Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("SHOW_TIMER"),"Value",Timer,"Func",function(_,value)
							_ARTG.SV.EditInformationDisplayItem("CR","Timer",value)
						end,
						"Type","CP","Text",Loc:Translation("FONT_COLOR"),"r",r,"g",g,"b",b,"a",a,"Func",
						function(_,r,g,b,a)
							_ARTG.SV.EditInformationDisplayItem("CR","Color",r,g,b,a)
						end)
					end 
				end 
				
			elseif SelectedOptionsTab == "INFODISPLAY_LOAD" then 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ALWAYS"),"Value",_ARTG.SV.GetVariable("ID_AlwaysLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_AlwaysLoad",value)
				end)
				Window.MenuBlock:AddRow("Type","Line")
				Window.MenuBlock:AddRow("Type","LB","Text",Loc:Translation("LOAD_WHEN_IN_CONTINUED"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_A_RAID_GROUP"),"Value",_ARTG.SV.GetVariable("ID_RaidLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_RaidLoad",value)
				end)
					
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_A_RAID_INSTANCE"),"Value",_ARTG.SV.GetVariable("ID_RaidInLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_RaidInLoad",value)
				end)
					
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_GUILD_RAID_INSTANCE"),"Value",_ARTG.SV.GetVariable("ID_GuildRaidInLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_GuildRaidInLoad",value)
				end)    
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_5_INSTANCE"),"Value",_ARTG.SV.GetVariable("ID_KeystoneLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("ID_KeystoneLoad",value)
				end)
			elseif SelectedOptionsTab == "HEALERMANA_SETTINGS" then 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ENABLE"),"Value",_ARTG.SV.GetVariable("HMD_Enable"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_Enable",value)
				end)

					
				Window.MenuBlock:AddRow("Header",Loc:Translation("POSITION"))
				local SelectedAnchorFrame = nil
				for i,v in ipairs(NI_AnchorFrames[1]) do 
					if v == _ARTG.SV.GetVariable("HMD_Anchor") then 
						SelectedAnchorFrame = NI_AnchorFrames[2][i]
					end
				end 
				local SelectedAnchorPoint = nil
				for i,v in ipairs(_ARTG.Data.FrameAnchorPoints[1]) do 
					if v == _ARTG.SV.GetVariable("HMD_AnchorPoint") then 
						SelectedAnchorPoint = _ARTG.Data.FrameAnchorPoints[2][i]
					end
				end 
				Window.MenuBlock:AddRow("Type","SB","Value",SelectedAnchorFrame,"Options",NI_AnchorFrames[2],"Func",function(self,Value, Index)  
					if NI_AnchorFrames[1][Index] then 
						_ARTG.SV.SaveVariable("HMD_Anchor",NI_AnchorFrames[1][Index])
					end 
				end,"Type","SB","Value",SelectedAnchorPoint,"Options",_ARTG.Data.FrameAnchorPoints[2],"Func",function(self,Value, Index)  
					if _ARTG.Data.FrameAnchorPoints[1][Index] then 
						_ARTG.SV.SaveVariable("HMD_AnchorPoint",_ARTG.Data.FrameAnchorPoints[1][Index])
					end 
				end) 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("LOCK_POSITION"),"Value",_ARTG.SV.GetVariable("HMD_Locked"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_Locked",value)
				end,
				"Type","DB","Text",Loc:Translation("RESET_POSITION"),"Func",function()
					_ARTG.SV.SaveVariable("HMD_PosX",0,true)
					_ARTG.SV.SaveVariable("HMD_PosY",0)
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("DIMENSIONS"))
				Window.MenuBlock:AddRow("Type","NB","Text",Loc:Translation("SCALE"),"Value",_ARTG.SV.GetVariable("HMD_Scale"),"Min",0.5,"Step",0.01,"Max",2,
				"Func",function(self, value)
					_ARTG.SV.SaveVariable("HMD_Scale",value)
				end)
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("MATCH_WIDTH"),"Value",_ARTG.SV.GetVariable("HMD_MatchWidth"),
				"Tooltip",Loc:Translation("MATCH_WIDTH_ATTACHED_DISPLAY"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_MatchWidth",value)
				end)
				Window.MenuBlock:AddRow("Type","NB","Text",Loc:Translation("WIDTH"),"Value",_ARTG.SV.GetVariable("HMD_Width"),"Min",100,"Step",10,"Max",450,
				"Func",function(self, value)
					_ARTG.SV.SaveVariable("HMD_Width",value)
				end,
				"Type","NB","Text",Loc:Translation("BAR_HEIGHT"),"Value",_ARTG.SV.GetVariable("HMD_BarHeight"),"Min",5,"Step",5,"Max",100,
				"Func",function(self, value)
					_ARTG.SV.SaveVariable("HMD_BarHeight",value)
				end)

				Window.MenuBlock:AddRow("Header",Loc:Translation("BACKGROUND"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("MATCH_BACKGROUND"),"Value",_ARTG.SV.GetVariable("HMD_MatchBackdrop"),
				"Tooltip",Loc:Translation("MATCH_BACKGROUND_ATTACHED_DISPLAY"),"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_MatchBackdrop",value)
				end)
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("BACKGROUND_COLOR"),"Value",_ARTG.SV.GetVariable("HMD_Backdrop"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_Backdrop",value)
				end,
				"Type","CP","r",_ARTG.SV.GetVariable("HMD_Backdropr"),"g",_ARTG.SV.GetVariable("HMD_Backdropg"),
				"b",_ARTG.SV.GetVariable("HMD_Backdropb"),"a",_ARTG.SV.GetVariable("HMD_Backdropa"),"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("HMD_Backdropr",r, true)
					_ARTG.SV.SaveVariable("HMD_Backdropg",g, true)
					_ARTG.SV.SaveVariable("HMD_Backdropb",b, true)
					_ARTG.SV.SaveVariable("HMD_Backdropa",a)
				end,"FixedWidth",20)
			elseif SelectedOptionsTab == "HEALERMANA_ADVANCED" then 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("IGNORE_OWN_MANA_BAR"),"Value",_ARTG.SV.GetVariable("HMD_IgnoreOwn"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_IgnoreOwn",value)
				end)
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CHECK_ZONE"),"Tooltip",Loc:Translation("ZONE_MATCH_HEALERS"),"Value",_ARTG.SV.GetVariable("HMD_MatchZone"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_MatchZone",value)
				end)
				--
				--[[Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("FREQUENT_UPDATES"),"Value",_ARTG.SV.GetVariable("HMD_FrequentUpdate"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_FrequentUpdate",value)
				end)]]

				Window.MenuBlock:AddRow("Header",Loc:Translation("BAR_COLOR"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("USE_CLASS_COLOR"),"Value",_ARTG.SV.GetVariable("HMD_BarClassColor"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_BarClassColor",value)
				end,
				"Type","CP","r",_ARTG.SV.GetVariable("HMD_BarColorr"),"g",_ARTG.SV.GetVariable("HMD_BarColorg"),
				"b",_ARTG.SV.GetVariable("HMD_BarColorb"),"a",_ARTG.SV.GetVariable("HMD_BarColora"),"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("HMD_BarColorr",r, true)
					_ARTG.SV.SaveVariable("HMD_BarColorg",g, true)
					_ARTG.SV.SaveVariable("HMD_BarColorb",b, true)
					_ARTG.SV.SaveVariable("HMD_BarColora",a)
				end,"FixedWidth",20)

				Window.MenuBlock:AddRow("Header",Loc:Translation("FONT_COLOR"))
				Window.MenuBlock:AddRow("Type","CP","Text",Loc:Translation("COLOR"),"r",_ARTG.SV.GetVariable("HMD_BarFontColorr"),"g",_ARTG.SV.GetVariable("HMD_BarFontColorg"),
				"b",_ARTG.SV.GetVariable("HMD_BarFontColorb"),"a",_ARTG.SV.GetVariable("HMD_BarFontColora"),"Func",function(_,r,g,b,a)
					_ARTG.SV.SaveVariable("HMD_BarFontColorr",r, true)
					_ARTG.SV.SaveVariable("HMD_BarFontColorg",g, true)
					_ARTG.SV.SaveVariable("HMD_BarFontColorb",b, true)
					_ARTG.SV.SaveVariable("HMD_BarFontColora",a)
				end)

			elseif SelectedOptionsTab == "HEALERMANA_LOAD" then 
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("ALWAYS"),"Value",_ARTG.SV.GetVariable("HMD_AlwaysLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_AlwaysLoad",value)
				end)
				Window.MenuBlock:AddRow("Type","Line")
				Window.MenuBlock:AddRow("Type","LB","Text",Loc:Translation("LOAD_WHEN_IN_CONTINUED"))
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_A_RAID_GROUP"),"Value",_ARTG.SV.GetVariable("HMD_RaidLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_RaidLoad",value)
				end)
					
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_A_RAID_INSTANCE"),"Value",_ARTG.SV.GetVariable("HMD_RaidInLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_RaidInLoad",value)
				end)
					
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_GUILD_RAID_INSTANCE"),"Value",_ARTG.SV.GetVariable("HMD_GuildRaidInLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_GuildRaidInLoad",value)
				end)    
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_5_INSTANCE"),"Value",_ARTG.SV.GetVariable("HMD_InstanceLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_InstanceLoad",value)
				end)
				Window.MenuBlock:AddRow("Type","CB","Text",Loc:Translation("CONTINUES_MYTHIC_KEYSTONE"),"Value",_ARTG.SV.GetVariable("HMD_KeystoneLoad"),
				"Func",function(self,value)
					_ARTG.SV.SaveVariable("HMD_KeystoneLoad",value)
				end)
			else 
				Window.MenuBlock:AddRow("Type","LB","Text",Loc:Translation("MISSING_OPTIONS"))
				Window.MenuBlock:AddRow("Type","TB","Value",SelectedOptionsTab)
			end 
		end 
	end
end 

Menu.UpdateCurrentNote = function(self)
	if QuickWindow then 
		QuickWindow.SaveButton:SetDisable(not _ARTG.SV.GetVariable("CurrentNote")["Name"]) 
		QuickWindow.ClearButton:SetDisable(not _ARTG.SV.GetVariable("CurrentNote")["Name"]) 
	end 
	if Window then 

	end 
end 
