local _ARTG = _Avyr_Raid_Tools_ADDON_Globals
local insert, remove = table.insert, table.remove
local Widgets = _Avyr_Global_ADDON_Elements_Lib:Initialize("AvyrRaidTools","Widgets")

_ARTG.SV = {}

--[[
_ARTG.SV.SettingsInfo = {
    ["G_Enable"] = {"boolean","Enable addon","Enables/disables the vast majority of the addons capabilities."}
}]]

_ARTG.SV.Components = {
    {"Minimap icon", "MI_Enable"},
    {"Note display", "ND_Enable"}
}

local DefaultSettings = {
    --global
    ["G_Enable"] = true,

    ["G_NormalColorr"] = 1,
    ["G_NormalColorg"] = 1,
    ["G_NormalColorb"] = 1,

    ["G_HighlightColorr"] = 1,
    ["G_HighlightColorg"] = 0.82,
    ["G_HighlightColorb"] = 0,

    ["G_BackdropColorr"] = 0.1,
    ["G_BackdropColorg"] = 0.1,
    ["G_BackdropColorb"] = 0.1,
    ["G_BackdropColora"] = 0.9,

    ["G_BorderColorr"] = 0,
    ["G_BorderColorg"] = 0,
    ["G_BorderColorb"] = 0,
    ["G_BorderColora"] = 1,

    --Menu
    ["GM_PosX"] = 0,
    ["GM_PosY"] = 0,
    ["GM_Scale"] = 1,
    ["GM_Locked"] = false,

    --minimap icon
    ["MI_PosX"] = -12,
    ["MI_PosY"] = -80,
    ["MI_Enable"] = true,

    --Editor Stuff
    ["NE_PosX"] = 0,
    ["NE_PosY"] = 0,
    ["NE_Scale"] = 1,
    ["NE_FullScreen"] = false,

    --note display options
    ["ND_Enable"] = true,
    ["ND_Width"] = 200,
    ["ND_Height"] = 300,

    ["ND_Locked"] = false,
    ["ND_PosX"] = 0,
    ["ND_PosY"] = 0,
    ["ND_Scale"] = 1,

    ["ND_AlwaysLoad"] = false,
    ["ND_RaidLoad"] = true,
    ["ND_RaidInLoad"] = true,
    ["ND_GuildRaidInLoad"] = true,

    ["ND_NoNoteHide"] = true,

    ["ND_NoteFontr"] = 1,
    ["ND_NoteFontg"] = 1,
    ["ND_NoteFontb"] = 1,
    ["ND_NoteFonta"] = 1,

    ["ND_ConditionFontr"] = 1,
    ["ND_ConditionFontg"] = 0.82,
    ["ND_ConditionFontb"] = 0,
    ["ND_ConditionFonta"] = 1,

    ["ND_Backdrop"] = true,
    ["ND_Backdropr"] = 0,
    ["ND_Backdropg"] = 0,
    ["ND_Backdropb"] = 0,
    ["ND_Backdropa"] = 0.33,

    ["ND_HighlightCurrent"] = true,
    ["ND_HighlightCurrentr"] = 1,
    ["ND_HighlightCurrentg"] = 0.87,
    ["ND_HighlightCurrentb"] = 0,
    ["ND_HighlightCurrenta"] = 0.25,

    ["ND_HighlightNext"] = true,
    ["ND_HighlightNextr"] = 0.2,
    ["ND_HighlightNextg"] = 0.2,
    ["ND_HighlightNextb"] = 0.87,
    ["ND_HighlightNexta"] = 0.25,

    ["ND_TransitionTime"] = 0.5,
    ["ND_SmoothScroll"] = true,

    --Keyword stuff
    ["ND_EnableKeywords"] = true,
    
    ["ND_KeywordsBorderHighlight"] = true,
    ["ND_KeywordsBorderHighlightr"] = 1,
    ["ND_KeywordsBorderHighlightg"] = 0.87,
    ["ND_KeywordsBorderHighlightb"] = 0,
    ["ND_KeywordsBorderHighlighta"] = 1,

    ["ND_EnableSound"] = false,
    ["ND_BaseSound"] = 12867,

    --info display stuff
    ["ID_Enable"] = true,
    ["ID_Scale"] = 1,
    ["ID_RowHeight"] = 20,
    ["ID_Width"] = 200,
    ["ID_Locked"] = false,

    ["ID_Anchor"] = "NOTEDISPLAY",
    ["ID_AnchorPoint"] = "TOP",
    ["ID_MatchWidth"] = true, 
    ["ID_PosX"] = 0,
    ["ID_PosY"] = 0,

    ["ID_MatchBackdrop"] = true,
    ["ID_Backdrop"] = true,
    ["ID_Backdropr"] = 0,
    ["ID_Backdropg"] = 0,
    ["ID_Backdropb"] = 0,
    ["ID_Backdropa"] = 0.33,

    ["ID_AlwaysLoad"] = false,
    ["ID_RaidLoad"] = true,
    ["ID_RaidInLoad"] = true,
    ["ID_GuildRaidInLoad"] = true,
    ["ID_KeystoneLoad"] = false,

    --healer mana display
    ["HMD_Enable"] = true,
    ["HMD_Scale"] = 1,
    ["HMD_BarHeight"] = 20,
    ["HMD_Width"] = 220,
    ["HMD_Locked"] = false,

    ["HMD_Anchor"] = "NOTEDISPLAY",
    ["HMD_AnchorPoint"] = "BOTTOM",
    ["HMD_MatchWidth"] = true, 
    ["HMD_PosX"] = 0,
    ["HMD_PosY"] = 0,
    --["HMD_FrequentUpdate"] = false,
    ["HMD_IgnoreOwn"] = false,
    ["HMD_MatchZone"] = true,

    ["HMD_MatchBackdrop"] = true,
    ["HMD_Backdrop"] = true,
    ["HMD_Backdropr"] = 0,
    ["HMD_Backdropg"] = 0,
    ["HMD_Backdropb"] = 0,
    ["HMD_Backdropa"] = 0.33,

    ["HMD_BarClassColor"] = false,
    ["HMD_BarColorr"] = 0.25,
    ["HMD_BarColorg"] = 0.25,
    ["HMD_BarColorb"] = 1,
    ["HMD_BarColora"] = 1,
    
    ["HMD_BarFontColorr"] = 1,
    ["HMD_BarFontColorg"] = 0.82,
    ["HMD_BarFontColorb"] = 0,
    ["HMD_BarFontColora"] = 1,

    ["HMD_AlwaysLoad"] = false,
    ["HMD_RaidLoad"] = true,
    ["HMD_RaidInLoad"] = true,
    ["HMD_GuildRaidInLoad"] = true,
    ["HMD_InstanceLoad"] = true,
    ["HMD_KeystoneLoad"] = true,
}
local RenamedOptions = {
    {"ND_Header","ID_Enable"},
    {"ND_HeaderScale","ID_Scale"},
    {"ND_HeaderAnchor","ID_AnchorPoint"},
}


local Loaded = false


_ARTG.SV.Load = function(self)
    AvyrRaidTools_DB = AvyrRaidTools_DB or {}
    AvyrRaidTools_DB.Notes = AvyrRaidTools_DB.Notes or {}
    AvyrRaidTools_DB.CurrentNote = AvyrRaidTools_DB.CurrentNote or {}

    --old editor stuff
    AvyrRaidTools_DB.MemberNames = AvyrRaidTools_DB.MemberNames or {}
    AvyrRaidTools_DB.MemberNames.LastRaid = AvyrRaidTools_DB.MemberNames.LastRaid or {}
    AvyrRaidTools_DB.MemberNames.LastUsed = AvyrRaidTools_DB.MemberNames.LastUsed or {}

    AvyrRaidTools_DB.EditorCooldowns = AvyrRaidTools_DB.EditorCooldowns or {}
    AvyrRaidTools_DB.EditorCooldowns.Favorites = AvyrRaidTools_DB.EditorCooldowns.Favorites or {}
    AvyrRaidTools_DB.EditorCooldowns.LastCreated = AvyrRaidTools_DB.EditorCooldowns.LastCreated or {}

    AvyrRaidTools_DB.ID_Data = AvyrRaidTools_DB.ID_Data or {
		"ET:1:1:0.81177004800816:0.067562568126462:1:1:1:1", -- [1]
		"CR:1:1:0.87:0:1:1", -- [2]
	}

    AvyrRaidTools_DB.KeywordsCD = AvyrRaidTools_DB.KeywordsCD or {}
    AvyrRaidTools_DB.Keywords = AvyrRaidTools_DB.Keywords or {}
    AvyrRaidTools_DB.KnownChars = AvyrRaidTools_DB.KnownChars or {}

    --renamed options
    for i,v in ipairs(RenamedOptions) do 
        if type(AvyrRaidTools_DB[v[1]]) ~= "nil" then 
            AvyrRaidTools_DB[v[2]] = AvyrRaidTools_DB[v[1]]
            AvyrRaidTools_DB[v[1]] = nil
        end
    end 

--[[
    ["ND_Header"] = true,
    ["ND_HeaderScale"] = 1,
    ["ND_HeaderAnchor"] = "TOP",

    ["ND_EncounterTimer"] = true,
    ["ND_EncounterTimerIcon"] = true,
    ["ND_EncounterTimerFontr"] = 1,
    ["ND_EncounterTimerFontg"] = 0.87,
    ["ND_EncounterTimerFontb"] = 0,
    ["ND_EncounterTimerFonta"] = 1,

    ["ND_CRCounter"] = true,
    ["ND_CRCounterTimer"] = true,
    ["ND_CRCounterIcon"] = true,
    ["ND_CRCounterFontr"] = 1,
    ["ND_CRCounterFontg"] = 0.87,
    ["ND_CRCounterFontb"] = 0,
    ["ND_CRCounterFonta"] = 1,

]]


    if type(AvyrRaidTools_DB["ND_EncounterTimer"]) ~= "nil" then 
        _ARTG.SV.EditInformationDisplayItem("EncounterTimer","Enable",AvyrRaidTools_DB["ND_EncounterTimer"])
        AvyrRaidTools_DB["ND_EncounterTimer"] = nil
        if type(AvyrRaidTools_DB["ND_EncounterTimerIcon"]) ~= "nil" then 
            _ARTG.SV.EditInformationDisplayItem("EncounterTimer","Icon",AvyrRaidTools_DB["ND_EncounterTimer"])
            AvyrRaidTools_DB["ND_EncounterTimerIcon"] = nil
        end 
        if type(AvyrRaidTools_DB["ND_EncounterTimerFontr"]) ~= "nil" and type(AvyrRaidTools_DB["ND_EncounterTimerFontg"]) ~= "nil" and 
        type(AvyrRaidTools_DB["ND_EncounterTimerFontb"]) ~= "nil" and type(AvyrRaidTools_DB["ND_EncounterTimerFonta"]) ~= "nil" then 
            _ARTG.SV.EditInformationDisplayItem("EncounterTimer","Color",AvyrRaidTools_DB["ND_EncounterTimerFontr"],AvyrRaidTools_DB["ND_EncounterTimerFontg"], 
            AvyrRaidTools_DB["ND_EncounterTimerFontb"],AvyrRaidTools_DB["ND_EncounterTimerFonta"])
            AvyrRaidTools_DB["ND_EncounterTimerFontr"] = nil;AvyrRaidTools_DB["ND_EncounterTimerFontg"] = nil
            AvyrRaidTools_DB["ND_EncounterTimerFontb"] = nil;AvyrRaidTools_DB["ND_EncounterTimerFonta"] = nil
        end 
    end 

    if type(AvyrRaidTools_DB["ND_CRCounter"]) ~= "nil" then 
        _ARTG.SV.EditInformationDisplayItem("CombatRezz","Enable",AvyrRaidTools_DB["ND_CRCounter"])
        AvyrRaidTools_DB["ND_CRCounter"] = nil
        if type(AvyrRaidTools_DB["ND_CRCounterIcon"]) ~= "nil" then 
            _ARTG.SV.EditInformationDisplayItem("CombatRezz","Icon",AvyrRaidTools_DB["ND_CRCounterIcon"])
            AvyrRaidTools_DB["ND_CRCounterIcon"] = nil
        end 
        if type(AvyrRaidTools_DB["ND_CRCounterTimer"]) ~= "nil" then 
            _ARTG.SV.EditInformationDisplayItem("CombatRezz","Timer",AvyrRaidTools_DB["ND_CRCounterTimer"])
            AvyrRaidTools_DB["ND_CRCounterTimer"] = nil
        end 
        if type(AvyrRaidTools_DB["ND_CRCounterFontr"]) ~= "nil" and type(AvyrRaidTools_DB["ND_CRCounterFontg"]) ~= "nil" and 
        type(AvyrRaidTools_DB["ND_CRCounterFontb"]) ~= "nil" and type(AvyrRaidTools_DB["ND_CRCounterFonta"]) ~= "nil" then 
            _ARTG.SV.EditInformationDisplayItem("CombatRezz","Color",AvyrRaidTools_DB["ND_CRCounterFontr"],AvyrRaidTools_DB["ND_CRCounterFontg"], 
            AvyrRaidTools_DB["ND_CRCounterFontb"],AvyrRaidTools_DB["ND_CRCounterFonta"])
            AvyrRaidTools_DB["ND_CRCounterFontr"] = nil;AvyrRaidTools_DB["ND_CRCounterFontg"] = nil
            AvyrRaidTools_DB["ND_CRCounterFontb"] = nil;AvyrRaidTools_DB["ND_CRCounterFonta"] = nil
        end 
    end 

    for i,v in pairs(DefaultSettings) do 
        if type(AvyrRaidTools_DB[i]) == "nil" then 
            AvyrRaidTools_DB[i] = v
        end 
    end 

    --_ARTG.CheckNoteVersion(AvyrRaidTools_DB.CurrentNote)

    if AvyrRaidTools_DB.CurrentNote and AvyrRaidTools_DB.CurrentNote.Info then 
        local Info = {strsplit(":",AvyrRaidTools_DB.CurrentNote.Info)}
        AvyrRaidTools_DB.CurrentNote.Expansion = tonumber(Info[1])
        AvyrRaidTools_DB.CurrentNote.Raid = tonumber(Info[2])
        AvyrRaidTools_DB.CurrentNote.Boss = tonumber(Info[3])
        local Version = Info[4]
        if type(Version) == "nil" then 
            for i,v in ipairs(AvyrRaidTools_DB.CurrentNote.Data) do 
                v[2] = v[2]:gsub("!cd","\023")
            end 
        end
        AvyrRaidTools_DB.CurrentNote.Info = nil
    end 


    if not AvyrRaidTools_DB.Notes.Version then 
        local NewNotes = {}
        for i,Note in ipairs(AvyrRaidTools_DB.Notes) do 
            --_ARTG.CheckNoteVersion(Note)
            if Note.Info then 
                local Info = {strsplit(":",Note.Info)}
                local Expansion = tonumber(Info[1])
                local Raid = tonumber(Info[2])
                local Boss = tonumber(Info[3])
                local Version = Info[4]
                if type(Version) == "nil" then 
                    for i,v in ipairs(Note.Data) do 
                        v[2] = v[2]:gsub("!cd","\023")
                    end 
                end
                if Expansion then 
                    NewNotes[Expansion] = NewNotes[Expansion] or {}
                    if Raid then 
                        NewNotes[Expansion][Raid] = NewNotes[Expansion][Raid] or {}
                        if Boss then 
                            NewNotes[Expansion][Raid][Boss] = NewNotes[Expansion][Raid][Boss] or {}
                            insert(NewNotes[Expansion][Raid][Boss],{
                                Name = Note.Name,
                                Description = Note.Description,
                                Data = Note.Data,
                            })
                        else 
                            NewNotes[Expansion][Raid]["Other"] = NewNotes[Expansion][Raid]["Other"] or {}
                            insert(NewNotes[Expansion][Raid]["Other"],{
                                Name = Note.Name,
                                Description = Note.Description,
                                Data = Note.Data,
                            })
                        end
                    else 
                        NewNotes[Expansion]["Other"] = NewNotes[Expansion]["Other"] or {}
                        insert(NewNotes[Expansion]["Other"],{
                            Name = Note.Name,
                            Description = Note.Description,
                            Data = Note.Data,
                        })
                    end 
                else 
                    NewNotes["Other"] = NewNotes["Other"] or {}
                    insert(NewNotes["Other"],{
                        Name = Note.Name,
                        Description = Note.Description,
                        Data = Note.Data,
                    })
                end 
            end 
        end 
        AvyrRaidTools_DB.Notes = NewNotes
        AvyrRaidTools_DB.Notes.Version = 1
    end 
    Loaded = true 

    
    Widgets:SetTheme("Normal",AvyrRaidTools_DB["G_NormalColorr"],AvyrRaidTools_DB["G_NormalColorg"],AvyrRaidTools_DB["G_NormalColorb"])
    Widgets:SetTheme("Highlight",AvyrRaidTools_DB["G_HighlightColorr"],AvyrRaidTools_DB["G_HighlightColorg"],AvyrRaidTools_DB["G_HighlightColorb"])
    Widgets:SetTheme("Border",AvyrRaidTools_DB["G_BorderColorr"],AvyrRaidTools_DB["G_BorderColorg"],AvyrRaidTools_DB["G_BorderColorb"],AvyrRaidTools_DB["G_BorderColora"])
    Widgets:SetTheme("Backdrop",AvyrRaidTools_DB["G_BackdropColorr"],AvyrRaidTools_DB["G_BackdropColorg"],AvyrRaidTools_DB["G_BackdropColorb"],AvyrRaidTools_DB["G_BackdropColora"])

    _ARTG.MinimapIcon:Refresh()
    _ARTG.NoteDisplay:Load()
end 


--[[
["Notes"] = {
		{
			["Info"] = "8:1179:2304:1",
			["Data"] = {
				{
					"T:10:5", -- [1]
					" Felvyr", -- [2]
				}, -- [1]
				{
					"RH::50::0:0:0:", -- [1]
					"entry 2 Felvyr", -- [2]
				}, -- [2]
				{
					"RH:29:50:2.5:0:1:0:", -- [1]
					"entry 3", -- [2]
				}, -- [3]
				{
					"T:40:5", -- [1]
					"entry 4 31821::", -- [2]
				}, -- [4]
				{
					"A:43:296688:2.5:1:1:0", -- [1]
					"test Felvyr", -- [2]
				}, -- [5]
			},
			["Name"] = "First note",
			["Description"] = "",
		}, -- [1]
		{
			["Info"] = "6:457:1691:1",
			["Data"] = {
				{
					"A::155080::1:0:1", -- [1]
					"test", -- [2]
				}, -- [1]
				{
					"A::155080::1:0:1", -- [1]
					"test 2", -- [2]
				}, -- [2]
				{
					"A::155080::1:0:1", -- [1]
					"test 3", -- [2]
				}, -- [3]
				{
					"A::155080::1:0:1", -- [1]
					"test 4", -- [2]
				}, -- [4]
			},
			["Description"] = "",
			["Name"] = "Gruul test",
		}, -- [2]
		{
			["Description"] = "",
			["Name"] = "New Note",
			["Data"] = {
				{
					"T:10:5", -- [1]
					"felvyr", -- [2]
				}, -- [1]
				{
					"T:15:5", -- [1]
					"test entry 196718:Felvyr:", -- [2]
				}, -- [2]
				{
					"T:17:5", -- [1]
					"Felvyr", -- [2]
				}, -- [3]
			},
			["Info"] = "8:1179:2311:1",
		}, -- [3]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (1)",
		}, -- [4]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (2)",
		}, -- [5]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (3)",
		}, -- [6]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (4)",
		}, -- [7]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (5)",
		}, -- [8]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (6)",
		}, -- [9]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (7)",
		}, -- [10]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (8)",
		}, -- [11]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (9)",
		}, -- [12]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (10)",
		}, -- [13]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (11)",
		}, -- [14]
		{
			["Description"] = "",
			["Info"] = "8:1179::1",
			["Name"] = "New Note (12)",
		}, -- [15]
		{
			["Name"] = "New Note (13)",
			["Description"] = "",
			["Info"] = ":::1",
		}, -- [16]
		{
			["Description"] = "",
			["Info"] = ":::1",
			["Name"] = "New Note (14)",
		}, -- [17]
		{
			["Info"] = ":::1",
			["Name"] = "New Note (15)",
			["Description"] = "",
		}, -- [18]
	},


]]

_ARTG.SV.ResetSettings = function()
    for i,v in pairs(DefaultSettings) do 
        AvyrRaidTools_DB[i] = v
    end 
    _ARTG.SV.SaveVariable("ALL")
end 

--local Centerx, Centery = UIParent:GetCenter();
_ARTG.SV.GetVariable = function(varName)
    if Loaded then 
        return AvyrRaidTools_DB[varName]
    end 
end 


_ARTG.SV.SaveVariable = function(varName,varValue, SurppressUpdate) 
    if varName ~= "ALL" then 
        AvyrRaidTools_DB[varName] = varValue
    end 
    
    --variable call backs
    if not SurppressUpdate then 
        --CORE STUFF
        if varName == "ALL" or varName == "G_Enable" or varName == "ND_AlwaysLoad" or varName == "ND_RaidLoad" or varName == "ND_GuildRaidLoad" or 
            varName == "ND_LoadCurrentNoteRaid" or varName == "CurrentNote" or varName == "ND_Enable" then 
            _ARTG:RegisterEvents()   
        end 
        
        --editor stuff
        if varName == "ALL" or varName == "NE_PosX" or varName == "NE_PosY" or varName == "NE_Scale" or varName == "NE_FullScreen" then 
            _ARTG.Editor:UpdatePosition()
        end 

        if varName == "CurrentNote" then 
            _ARTG.Editor:Refresh()
        end 

        --Menu stuff
        if varName == "ALL" or varName == "GM_Scale" or varName == "GM_PosX" or varName == "GM_PosY" or varName == "GM_Locked" then 
            _ARTG.OptionsMenu:UpdateDimensions()
        end 

        if varName == "ALL" or varName == "CurrentNote" then 
            _ARTG.OptionsMenu:UpdateCurrentNote()
        end 

        if varName == "ALL" or varName == "G_NormalColorr" or varName == "G_NormalColorg" or varName == "G_NormalColorb" then 
            Widgets:SetTheme("Normal",AvyrRaidTools_DB["G_NormalColorr"],AvyrRaidTools_DB["G_NormalColorg"],AvyrRaidTools_DB["G_NormalColorb"],1)
        end 

        if varName == "ALL" or varName == "G_HighlightColorr" or varName == "G_HighlightColorg" or varName == "G_HighlightColorb" then 
            Widgets:SetTheme("Highlight",AvyrRaidTools_DB["G_HighlightColorr"],AvyrRaidTools_DB["G_HighlightColorg"],AvyrRaidTools_DB["G_HighlightColorb"],1)
        end 

        if varName == "ALL" or varName == "G_BackdropColorr" or varName == "G_BackdropColorg" or varName == "G_BackdropColorb" or varName == "G_BackdropColora" then 
            Widgets:SetTheme("Backdrop",AvyrRaidTools_DB["G_BackdropColorr"],AvyrRaidTools_DB["G_BackdropColorg"],AvyrRaidTools_DB["G_BackdropColorb"],AvyrRaidTools_DB["G_BackdropColora"])
        end 

        if varName == "ALL" or varName == "G_BorderColorr" or varName == "G_BorderColorg" or varName == "G_BorderColorb" or varName == "G_BorderColora" then  
            Widgets:SetTheme("Border",AvyrRaidTools_DB["G_BorderColorr"],AvyrRaidTools_DB["G_BorderColorg"],AvyrRaidTools_DB["G_BorderColorb"],AvyrRaidTools_DB["G_BorderColora"])
        end 

        --MINIMAP STUFF
        if varName == "ALL" or varName == "G_Enable" or varName == "MI_Enable" or varName == "MI_PosX" or varName == "MI_PosY" then 
            _ARTG.MinimapIcon:Refresh()
        end 

        --DISPLAY STUFF
        if varName == "ALL" or varName == "G_Enable" or varName == "ND_AlwaysLoad" or varName == "ND_RaidLoad" or varName == "ND_GuildRaidLoad" or 
            varName == "ND_GuildRaidInLoad" or
            varName == "ND_LoadCurrentNoteRaid" or varName == "CurrentNote" or varName == "ND_Enable" or varName == "ND_NoNoteHide" then 
            _ARTG.NoteDisplay:Load()   
        end 

        if varName == "ALL" or varName == "ND_PosX" or varName == "ND_PosY" or varName == "ND_Scale" or varName == "ND_Locked" then 
            _ARTG.NoteDisplay:UpdatePosition()
        end 

        if varName == "ALL" or varName == "ND_Width" or varName == "ND_Height" then 
            _ARTG.NoteDisplay:UpdateDimensions()
        end 

        if varName == "ALL" or varName == "ND_Backdrop" or varName == "ND_Backdropr" or varName == "ND_Backdropg" or varName == "ND_Backdropb" or varName == "ND_Backdropa" 
        or varName == "ND_NoteFontr" or varName == "ND_NoteFontg" or varName == "ND_NoteFontb" or varName == "ND_NoteFonta" 
        or varName == "ND_ConditionFontr" or varName == "ND_ConditionFontg" or varName == "ND_ConditionFontb" or varName == "ND_ConditionFonta" 
        or varName == "ND_HighlightCurrent" or varName == "ND_HighlightCurrentr" or varName == "ND_HighlightCurrentg" or varName == "ND_HighlightCurrentb" or varName == "ND_HighlightCurrenta" 
        or varName == "ND_HighlightNext" or varName == "ND_HighlightNextr" or varName == "ND_HighlightNextg" or varName == "ND_HighlightNextb" or varName == "ND_HighlightNexta" 
        then 
            _ARTG.NoteDisplay:UpdateColors()
        end 
		
        if varName == "ALL" or varName == "ND_EnableKeywords" or varName == "ND_KeywordsBorderHighlight" or varName == "ND_KeywordsBorderHighlightr" or 
        varName == "ND_KeywordsBorderHighlightg" or varName == "ND_KeywordsBorderHighlightb" or varName == "ND_KeywordsBorderHighlighta" then 
            _ARTG.NoteDisplay:UpdateKeywords()
        end 

		--info display
        if varName == "ALL" or varName == "G_Enable" or varName == "ID_Enable" or 
            varName == "ID_AlwaysLoad" or varName == "ID_RaidLoad" or varName == "ID_GuildRaidLoad" or varName == "ID_GuildRaidInLoad" or varName == "ID_KeystoneLoad" then 
            _ARTG.InfoDisplay:Load()
        end 
        
        if varName == "ALL" or varName == "ID_Backdrop" or varName == "ID_Backdropr" or varName == "ID_Backdropg" or 
        varName == "ID_Backdropb" or varName == "ID_Backdropa" or varName == "ID_MatchBackdrop" or 
        varName == "ID_Anchor" or varName == "ID_AnchorPoint" or 
        (AvyrRaidTools_DB["ID_MatchBackdrop"] and (
            (AvyrRaidTools_DB["ID_Anchor"] == "NOTEDISPLAY" and 
                (varName == "ND_Backdrop" or varName == "ND_Backdropr" or varName == "ND_Backdropg" or varName == "ND_Backdropb" or varName == "ND_Backdropa")) 

        )) then  
            _ARTG.InfoDisplay:UpdateColor()
        end 

        if varName == "ALL" or varName == "ID_Scale" or varName == "ID_RowHeight" or varName == "ID_Width" or varName == "ID_MatchWidth" or 
        varName == "ID_Anchor" or varName == "ID_AnchorPoint" or varName == "ID_PosX" or varName == "ID_PosY" or varName == "ID_Locked" or 
            (AvyrRaidTools_DB["ID_Anchor"] == "NOTEDISPLAY" and 
                (varName == "ND_Width" or varName == "ND_Height" or varName == "ND_PosX" or varName == "ND_PosY" or varName == "ND_Scale")) 
                
        then 
            _ARTG.InfoDisplay:UpdateDimensions()
        end 

        --healer mana display
        if varName == "ALL" or varName == "G_Enable" or varName == "HMD_Enable" or varName == "HMD_AlwaysLoad" or varName == "HMD_RaidLoad" or 
        varName == "HMD_RaidInLoad" or varName == "HMD_GuildRaidInLoad" or varName == "HMD_InstanceLoad" or varName == "HMD_KeystoneLoad" then 
            _ARTG.HealerManaDisplay:Load()   
        end 

        if varName == "ALL" or varName == "HMD_Anchor" or varName == "HMD_AnchorPoint" or varName == "HMD_Locked" or varName == "HMD_MatchWidth" or 
        varName == "HMD_Scale" or varName == "HMD_PosX" or varName == "HMD_PosY" or varName == "HMD_Width" or varName == "HMD_BarHeight" then 
            _ARTG.HealerManaDisplay:UpdateDimensions()
        end 

		if varName == "ALL" or varName == "HMD_MatchBackdrop" or varName == "HMD_Backdrop" or varName == "HMD_Backdropr" or varName == "HMD_Backdropg" or 
		varName == "HMD_Backdropb" or varName == "HMD_Backdropa" or varName == "HMD_BarClassColor" or varName == "HMD_BarColorr" or varName == "HMD_BarColorg" or 
		varName == "HMD_BarColorb" or varName == "HMD_BarColora" or varName == "HMD_BarFontColorr" or varName == "HMD_BarFontColorg" or varName == "HMD_BarFontColorb" or 
		varName == "HMD_BarFontColora" then 
			_ARTG.HealerManaDisplay:UpdateColors()
		end

		if varName == "ALL" or varName == "HMD_IgnoreOwn" then 
			_ARTG.HealerManaDisplay:Refresh(UnitGUID("player"))
		end

		if varName == "ALL" or varName == "HMD_MatchZone" then 
			_ARTG.HealerManaDisplay:Refresh()
		end

        --_ARTG.SV.GetVariable("HMD_Anchor"),_ARTG.SV.GetVariable("HMD_AnchorPoint"),
          --  _ARTG.SV.GetVariable("HMD_Locked"),_ARTG.SV.GetVariable("HMD_MatchWidth"),_ARTG.SV.GetVariable("HMD_Scale"),
           -- _ARTG.SV.GetVariable("HMD_PosX"),_ARTG.SV.GetVariable("HMD_PosY")
        --[[
          ["HMD_Enable"] = true,
    ["HMD_Scale"] = 1,
    ["HMD_BarHeight"] = 20,
    ["HMD_Width"] = 220,
    ["HMD_Locked"] = false,

    ["HMD_Anchor"] = "NOTEDISPLAY",
    ["HMD_AnchorPoint"] = "BOTTOM",
    ["HMD_MatchWidth"] = true, 
    ["HMD_PosX"] = 0,
    ["HMD_PosY"] = 0,
    ["HMD_FrequentUpdate"] = false,
    ["HMD_IgnoreOwn"] = false,

    ["HMD_MatchBackdrop"] = true,
    ["HMD_Backdrop"] = true,
    ["HMD_Backdropr"] = 0,
    ["HMD_Backdropg"] = 0,
    ["HMD_Backdropb"] = 0,
    ["HMD_Backdropa"] = 0.33,

    ["HMD_BarClassColor"] = false,
    ["HMD_BarColorr"] = 0.25,
    ["HMD_BarColorg"] = 0.25,
    ["HMD_BarColorb"] = 1,
    ["HMD_BarColora"] = 1,
    
    ["HMD_BarFontColorr"] = 1,
    ["HMD_BarFontColorg"] = 1,
    ["HMD_BarFontColorb"] = 1,
    ["HMD_BarFontColora"] = 1,

    ["HMD_AlwaysLoad"] = false,
    ["HMD_RaidLoad"] = true,
    ["HMD_RaidInLoad"] = true,
    ["HMD_GuildRaidInLoad"] = true,
    ["HMD_InstanceLoad"] = true,
    ["HMD_KeystoneLoad"] = false,
      

		]]

        if varName == "ALL" then 
            if _ARTG.OpenMenu then 
                if _ARTG.OpenMenu == "Editor" then 
                    _ARTG.Editor:Call("Close")
                    _ARTG.Editor:Call("Open")
                elseif _ARTG.OpenMenu == "Menu" then 
                    _ARTG.OptionsMenu:Call("Close");
                    _ARTG.OptionsMenu:Call("Open");
                elseif _ARTG.OpenMenu == "QuickSelect" then  
                    _ARTG.OptionsMenu:QuickCall("Close");
                    _ARTG.OptionsMenu:QuickCall("Open");                
                end 
            end 
        end 
    end 
end 

_ARTG.SV.GetInformationDisplayItem = function(Action,String)
    if Action == "QuickCheck" then 

    elseif Action == "Unpack" then 
        local Data = {strsplit(":",String)}
        if Data[1] == "ET" then 
            --Type,Enable,r,g,b,a,Icon
            local Enable,r,g,b,a,Icon = true,1,1,1,1,true
            if Data[2] and Data[2] ~= "1" then 
                Enable = false
            end 
            if Data[3] and tonumber(Data[3]) then 
                r = tonumber(Data[3])
            end 
            if Data[4] and tonumber(Data[4]) then 
                g = tonumber(Data[4])
            end 
            if Data[5] and tonumber(Data[5]) then 
                b = tonumber(Data[5])
            end 
            if Data[6] and tonumber(Data[6]) then 
                a = tonumber(Data[6])
            end
            if Data[7] and Data[7] ~= "1" then 
                Icon = false
            end  
            return Enable,r,g,b,a,Icon
        elseif Data[1] == "CR" then 
            --Type,Enable,r,g,b,a,Icon,Timer,Count
            local Enable,r,g,b,a,Icon,Timer,Count = true,1,1,1,1,true,true,true
            if Data[2] and Data[2] ~= "1" then 
                Enable = false
            end 
            if Data[3] and tonumber(Data[3]) then 
                r = tonumber(Data[3])
            end 
            if Data[4] and tonumber(Data[4]) then 
                g = tonumber(Data[4])
            end 
            if Data[5] and tonumber(Data[5]) then 
                b = tonumber(Data[5])
            end 
            if Data[6] and tonumber(Data[6]) then 
                a = tonumber(Data[6])
            end
            if Data[7] and Data[7] ~= "1" then 
                Icon = false
            end  
            if Data[8] and Data[8] ~= "1" then 
                Timer = false
            end  
            if Data[9] and Data[9] ~= "1" then 
                Count = false
            end  
            return Enable,r,g,b,a,Icon,Timer,Count
        end 
    end
end 

--no action will create item if it doesnt exist
_ARTG.SV.EditInformationDisplayItem = function(Name,Action,...)
    local ChangesMade = false
    local Type
    if Name  == "EncounterTimer" or Name == "ET" then 
        Type = "ET"
    elseif Name == "CombatRezz" or Name == "CR" then 
        Type = "CR"
    end 
    if Type then 
        local CurrentIndex
        for i,v in ipairs(AvyrRaidTools_DB["ID_Data"]) do 
            if v:find(Type..":") then 
                CurrentIndex = i
                break 
            end 
        end 
        if not CurrentIndex then 
            if Type == "CR" then 
                insert(AvyrRaidTools_DB.ID_Data,"CR:")
            elseif Type == "ET" then 
                insert(AvyrRaidTools_DB.ID_Data,"ET:")
            end 
            CurrentIndex = getn(AvyrRaidTools_DB.ID_Data)
        end 

        if Action then 
            if Action == "Position" then 
                local Increment = ...
                if type(Increment) == "number" and Increment ~= 0 then 
                    local NewPos = CurrentIndex + Increment
                    if CurrentIndex ~= NewPos and NewPos > 0 and NewPos <= getn(AvyrRaidTools_DB.ID_Data) then 
                        local tempValue = AvyrRaidTools_DB.ID_Data[CurrentIndex]
                        remove(AvyrRaidTools_DB.ID_Data,CurrentIndex)
                        insert(AvyrRaidTools_DB.ID_Data,NewPos,tempValue)
                        ChangesMade = true 
                    end
                end
            end 
            if Type == "ET" then 
                local ET,Enable,r,g,b,a,Icon = strsplit(":",AvyrRaidTools_DB.ID_Data[CurrentIndex])
                Enable = Enable or "1"; r = r or "1"; g = g or "0.87"; b = b or "0"; a = a or "1"; Icon = Icon or "1"
                if Action == "Enable" then 
                    local EnableInput = ...
                    Enable = EnableInput and "1" or "0"
                    ChangesMade = true 
                elseif Action == "Icon" then 
                    local EnableIcon = ...
                    Icon = EnableIcon and "1" or "0"
                    ChangesMade = true 
                elseif Action == "Color" then 
                    local newr,newg,newb,newa = ...
                    r = type(newr) == "number" and newr or r
                    g = type(newg) == "number" and newg or g
                    b = type(newb) == "number" and newb or b
                    a = type(newa) == "number" and newa or a
                    ChangesMade = true 
                end 
                AvyrRaidTools_DB.ID_Data[CurrentIndex] = ET..":"..Enable..":"..r..":"..g..":"..b..":"..a..":"..Icon
            elseif Type == "CR" then 
                local ET,Enable,r,g,b,a,Icon,Timer,Count = strsplit(":",AvyrRaidTools_DB.ID_Data[CurrentIndex])
                Enable = Enable or "1"; r = r or "1"; g = g or "0.87"; b = b or "0"; a = a or "1"; Icon = Icon or "1"; Timer = Timer or "1"; Count = Count or "1"
                if Action == "Enable" then 
                    local EnableInput = ...
                    Enable = EnableInput and "1" or "0"
                    ChangesMade = true 
                elseif Action == "Icon" then 
                    local EnableIcon = ...
                    Icon = EnableIcon and "1" or "0"
                    ChangesMade = true 
                elseif Action == "Color" then 
                    local newr,newg,newb,newa = ...
                    r = type(newr) == "number" and newr or r
                    g = type(newg) == "number" and newg or g
                    b = type(newb) == "number" and newb or b
                    a = type(newa) == "number" and newa or a
                    ChangesMade = true 
                elseif Action == "Timer" then 
                    local EnableTimer = ...
                    Timer = EnableTimer and "1" or "0"
                    ChangesMade = true 
                elseif Action == "Count" then 
                    local EnableCount = ...
                    Count = EnableCount and "1" or "0"
                    ChangesMade = true 
                end 
                AvyrRaidTools_DB.ID_Data[CurrentIndex] = ET..":"..Enable..":"..r..":"..g..":"..b..":"..a..":"..Icon..":"..Timer..":"..Count   
            end   
        end
    end
    if ChangesMade then 
        _ARTG.InfoDisplay:Load()
        _ARTG.OptionsMenu:Refresh("INFODISPLAY_COMPONENTS",true)
    end 
end

function _ARTG.SV:AddMyCooldownKeyword(Type,arg1,arg2,arg3,arg4)
    local Term,CaseMatch,OverrideSound
    local CD
    local ChangesMade = false
    if Type == "Keyword" and type(arg1) ~= "nil" then 
        Term,CaseMatch,OverrideSound = arg1,arg2,arg3
        if Term then 
            for i,v in ipairs(AvyrRaidTools_DB.Keywords) do 
                if v.Term == Term then 
                    return 
                end 
            end 
            insert(AvyrRaidTools_DB.Keywords,{Term = Term, CM  = CaseMatch, Sound = OverrideSound})
            ChangesMade = "KW"
        end 
    elseif Type == "CD" and type(arg1) ~= "nil" and type(arg2) ~= "nil" then 
        Term = _ARTG.ConvertCD(arg1,arg2,"")
        CaseMatch,OverrideSound = arg3,arg4
        if Term then 
            for i,v in ipairs(AvyrRaidTools_DB.KeywordsCD) do 
                if v.Term == Term then 
                    return 
                end 
            end 
            insert(AvyrRaidTools_DB.KeywordsCD,{Term = Term, CM  = CaseMatch, Sound = OverrideSound})
            ChangesMade = "CD"
        end 
    end 
    if ChangesMade then 
        _ARTG.NoteDisplay:Load()
        if ChangesMade == "KW" then
            _ARTG.OptionsMenu:Refresh("DISPLAY_KEYWORDS_KEYWORDS",true)
        elseif ChangesMade == "CD" then
            _ARTG.OptionsMenu:Refresh("DISPLAY_KEYWORDS_CDS",true)
        end
    end 
end 

function _ARTG.SV:EditMyCooldownKeyword(Type,Action,...)
    local ChangesMade = false
    if Action == "Remove" then 
        local Index = ...
        if Type == "Keyword" then 
            remove(AvyrRaidTools_DB.Keywords,Index)
            ChangesMade = "KW"
        elseif Type == "CD" then 
            remove(AvyrRaidTools_DB.KeywordsCD,Index)
            ChangesMade = "CD"
        end 
    elseif Action == "Edit" then 
        --Term, CM, Sound
        local Index,VarName,VarValue = ...
        if Type == "Keyword" and AvyrRaidTools_DB.Keywords[Index] then 
            AvyrRaidTools_DB.Keywords[Index][VarName] = VarValue
            ChangesMade = "KW"
        elseif Type == "CD" and AvyrRaidTools_DB.KeywordsCD[Index] then 
            AvyrRaidTools_DB.KeywordsCD[Index][VarName] = VarValue
            ChangesMade = "CD"
        end    
    end 
    if ChangesMade then 
        _ARTG.NoteDisplay:Load()
        if ChangesMade == "KW" then
            _ARTG.OptionsMenu:Refresh("DISPLAY_KEYWORDS_KEYWORDS",true)
        elseif ChangesMade == "CD" then
            _ARTG.OptionsMenu:Refresh("DISPLAY_KEYWORDS_CDS",true)
        end
    end 
end 

function _ARTG.SV:IsCooldownKeyword(Type,Word)
    if Type == "Keyword" then 
		for i,v in ipairs(AvyrRaidTools_DB.Keywords) do
			if v.Term == Word then 
				return true 
			end
		end
	elseif Type == "CD" then 
		for i,v in ipairs(AvyrRaidTools_DB.KeywordsCD) do
			if v.Term == Word then 
				return true 
			end
		end
	end 
	return false 
end


_ARTG.SV.PrepareCharacter = function()
    local Name,Realm = UnitFullName("player")
    if not AvyrRaidTools_DB.KnownChars[Name.."-"..Realm] then 
        AvyrRaidTools_DB.KnownChars[Name.."-"..Realm] = {}
    end 
    --keyword stuff
    if not AvyrRaidTools_DB.KnownChars[Name.."-"..Realm].Keywords then 
        _ARTG.SV:AddMyCooldownKeyword("Keyword",Name)
        _ARTG.SV:AddMyCooldownKeyword("Keyword",Name.."-"..Realm)
        local _,_,classID = UnitClass("Player")
        if _ARTG.Data.Cooldowns[classID..""] then 
            for _,CDID in ipairs(_ARTG.Data.Cooldowns[classID..""]) do 
                _ARTG.SV:AddMyCooldownKeyword("CD",CDID,Name)
                _ARTG.SV:AddMyCooldownKeyword("CD",CDID,Name.."-"..Realm)
            end 
        end 
        for i = 1,GetNumSpecializations() do 
            if _ARTG.Data.Cooldowns[classID.."-"..GetSpecializationInfo(i)] then 
                for _,CDID in ipairs(_ARTG.Data.Cooldowns[classID.."-"..GetSpecializationInfo(i)]) do 
                    _ARTG.SV:AddMyCooldownKeyword("CD",CDID,Name)
                    _ARTG.SV:AddMyCooldownKeyword("CD",CDID,Name.."-"..Realm)
                end 

            end 
        end 
        AvyrRaidTools_DB.KnownChars[Name.."-"..Realm].Keywords = true 
    end 
    --profile stuff for later maybe
end 

_ARTG.SV.CheckNoteExists = function(Expansion,Raid,Boss,Index,ReturnDirectory)
    if (type(Expansion) == "string" or type(Expansion) == "number") and type(Index) == "number" then 
        if Expansion == "Deprecated" or Expansion == "Other" then 
            if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion][Index] then 
                if ReturnDirectory then 
                    return AvyrRaidTools_DB.Notes[Expansion]
                else 
                    return AvyrRaidTools_DB.Notes[Expansion][Index], Expansion
                end 
            end 
        else 
            if Raid == "Other" then 
                if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion][Raid] and AvyrRaidTools_DB.Notes[Expansion][Raid][Index] then 
                    if ReturnDirectory then 
                        return AvyrRaidTools_DB.Notes[Expansion][Raid]
                    else 
                        return AvyrRaidTools_DB.Notes[Expansion][Raid][Index], _ARTG.DataFuncs.GetRaidInfo("exp.data.name",Expansion) .. " > Other" 
                    end 
                end 
            else 
                if AvyrRaidTools_DB.Notes[Expansion] and AvyrRaidTools_DB.Notes[Expansion][Raid] and AvyrRaidTools_DB.Notes[Expansion][Raid][Boss] and 
                AvyrRaidTools_DB.Notes[Expansion][Raid][Boss][Index] then 
                    local ExpansionName = _ARTG.DataFuncs.GetRaidInfo("exp.data.name",Expansion)
                    local RaidName = _ARTG.DataFuncs.GetRaidInfo("raid.data.name",Raid,Expansion)
                    local BossName = _ARTG.DataFuncs.GetRaidInfo("boss.data.name",Boss,Raid,Expansion)
                    if ReturnDirectory then 
                        return AvyrRaidTools_DB.Notes[Expansion][Raid][Boss]
                    else 
                        return AvyrRaidTools_DB.Notes[Expansion][Raid][Boss][Index], ExpansionName .. " > " .. RaidName .. " > " .. BossName
                    end 
                end                
            end 
        end 
    end 
end 

_ARTG.SV.NoteEntry = function(Type,Action,...)
    if Type == "Header" then 
        if Action == "Summary" then 
            local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = _ARTG.SV.NoteEntry("Header","Unpack",...)
            if EntryType == "T" and arg1 and arg2 then 
                return _ARTG.ConvertToTime(arg1)
            elseif EntryType == "A" and arg3 and (not arg5 or (arg1 and arg2)) then 
                local SpellName,_,SpellIcon = GetSpellInfo(arg3)
                if SpellName then 
                    if arg5 then 
                        return _ARTG.ConvertToTime(arg1).." - |T"..SpellIcon..":0:0:0:0|t " .. SpellName
                    else 
                        return "|T"..SpellIcon..":0:0:0:0|t " .. SpellName
                    end 
                end 
            elseif EntryType == "RH" and arg3 and (not arg5 or (arg1 and arg2)) then
                if arg5 then 
                    return _ARTG.ConvertToTime(arg1).." - Avg. hp <"..arg3.."%"
                else 
                    return "Avg. hp <"..arg3.."%"
                end 
            end 
        elseif Action == "Unpack" then 
            --"T",Time,ErrorMargin
            --"A",Time,ErrorMargin,SpellID,ExactMatch,UseTime,IgnoreDoT
            --"RH",Time,ErrorMargin,AvgPercent,IgnoreTanks,UseTime
            if ... then 
                local NoteEntry = {strsplit(":",...)}
                if NoteEntry[1] == "T" then 
                    local Time,ErrorMargin
                    if NoteEntry[2] and tonumber(NoteEntry[2]) then 
                        Time = tonumber(NoteEntry[2])
                    end 
                    if NoteEntry[3] and tonumber(NoteEntry[3]) then 
                        ErrorMargin = tonumber(NoteEntry[3])
                    end 
                    return "T",Time,ErrorMargin
                elseif NoteEntry[1] == "A" then 
                    local Time,ErrorMargin,SpellID,ExactMatch,UseTime,IgnoreDoT
                    if NoteEntry[2] and tonumber(NoteEntry[2]) then 
                        Time = tonumber(NoteEntry[2])
                    end 
                    if NoteEntry[3] and tonumber(NoteEntry[3]) then 
                        SpellID = tonumber(NoteEntry[3])
                    end 
                    ExactMatch = (type(NoteEntry[5]) == "string" and NoteEntry[5] == "1")
                    UseTime = (type(NoteEntry[6]) == "string" and NoteEntry[6] == "1")
                    IgnoreDoT = (type(NoteEntry[7]) == "string" and NoteEntry[7] == "1")
                    if NoteEntry[4] and tonumber(NoteEntry[4]) then 
                        ErrorMargin = tonumber(NoteEntry[4])
                    end 
                    return "A",Time,ErrorMargin,SpellID,ExactMatch,UseTime,IgnoreDoT
                elseif NoteEntry[1] == "RH" then 
                    local Time,ErrorMargin,AvgPercent,IgnoreTanks,UseTime
                    if NoteEntry[2] and tonumber(NoteEntry[2]) then 
                        Time = tonumber(NoteEntry[2])
                    end 
                    if NoteEntry[3] and tonumber(NoteEntry[3]) then 
                        AvgPercent = tonumber(NoteEntry[3])
                    end 
                    IgnoreTanks = (type(NoteEntry[5]) == "string" and NoteEntry[5] == "1")
                    UseTime = (type(NoteEntry[6]) == "string" and NoteEntry[6] == "1")
                    if NoteEntry[4] and tonumber(NoteEntry[4]) then 
                        ErrorMargin = tonumber(NoteEntry[4]) 
                    end 
                    --[[
                    LimitAvg = (type(NoteEntry[7]) == "string" and NoteEntry[7] == "1")
                    if NoteEntry[8] and tonumber(NoteEntry[8]) then 
                        PlayersAvg = tonumber(NoteEntry[8])
                    end ]]
                    return "RH",Time,ErrorMargin,AvgPercent,IgnoreTanks,UseTime
                end 
            end
        elseif Action == "Pack" then 
            local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = ...
            if EntryType == "T" then 
                --type,time,errorMargin
                return "T:"..(arg1 or 0)..":"..(arg2 or 5) 
            elseif EntryType == "A" then 
                --type,time,spellID,errorMargin,exactMatch,useTime,ignoreDoT
                return "A:"..(arg1 or 0)..":"..(arg3 or "")..":"..(arg2 or 5)..":"..(arg4 and "1" or "0")..":"..(arg5 and "1" or "0")..":"..(arg6 and "1" or "0")
            elseif EntryType == "RH" then 
                --type,Time,AvgPercent,ErrorMargin,IgnoreTanks,UseTime
                return "RH:"..(arg1 or 0)..":"..(arg3 or 50)..":"..(arg2 or 5)..":"..(arg4 and "1" or "0")..":"..(arg5 and "1" or "0")
            end 
        end 
    elseif Type == "Note" then 
        if Action == "Summary" then 
            local Note = ...
            local ReturnNote = Note
            local CDs = {}
            if strmatch(Note,"\023%d+:%a*:%w*\023") then 
                for CDLink in Note:gmatch("\023%d+:%a*:%w*\023") do
                    ReturnNote = ReturnNote:gsub(CDLink,"/cd",1)
                    insert(CDs,CDLink)
                end 
            end 
            return ReturnNote, CDs
        elseif Action == "DisplaySummary" then 
            local Note = ...
            local ReturnNote = Note
            if strmatch(Note,"\023%d+:%a*:%w*\023") then 
                for CDLink in Note:gmatch("\023%d+:%a*:%w*\023") do
                    ReturnNote = ReturnNote:gsub(CDLink,_ARTG.SV.NoteEntry("CD","Display",CDLink).." ",1)
                end 
            end 
            local Keyword
            if _ARTG.SV.GetVariable("ND_EnableKeywords") then 
                if AvyrRaidTools_DB.Keywords then 
                    for _,word in ipairs(AvyrRaidTools_DB.Keywords) do  
                        if (word.CM and Note:find(word.Term)) or (not word.CM and Note:lower():find(word.Term:lower())) then 
                            if word.Sound then 
                                Keyword = word.Sound
                            else
                                Keyword = true  
                            end 
                            break 
                        end 
                    end 
                end  
                if not Keyword then 
                    for _,word in ipairs(AvyrRaidTools_DB.KeywordsCD) do  
                        if (word.CM and Note:find(word.Term)) or (not word.CM and Note:lower():find(word.Term:lower())) then 
                            if word.Sound then 
                                Keyword = word.Sound
                            else
                                Keyword = true  
                            end 
                            break 
                        end 
                    end 
                end 
            end
            return ReturnNote, Keyword            
        elseif Action == "Pack" then 
            local Note,CDs = ...
            for i = 1,getn(CDs) do 
                Note = Note:gsub("/cd",CDs[i],1)
            end 
            Note = Note:gsub("/cd","") --cleaning
            return Note
        end 
    elseif Type == "CD" then 
        if Action == "Display" then 
            local CDString = gsub(...,"\023","")
            local CD,Name,Mod = strsplit(":",CDString)
            if tonumber(CD) then 
                local CDID = tonumber(CD)
                if GetSpellInfo(CDID) then 
                    local _,_,Icon = GetSpellInfo(CDID)  
                    Icon = Icon or 134400
                    if Name == "" then 
                        return "|T"..Icon..":0:0:0:0|t",CDID,Name         
                    else 
                        return "|T"..Icon..":0:0:0:0|t"..Name,CDID,Name                
                    end  
                end 
                return "Unknown CD ",CDID,Name
            end 
            return "Unknown CD ",CD,Name
        elseif Action == "Create" then 
            local CD,Name,Mod = ...
            CD = CD or ""
            Name = Name or ""
            Mod = Mod or ""
            return "\023"..CD..":"..Name..":"..Mod.."\023"
        end 
    end 
end 

_ARTG.SV.NoteSort = function(Note)
    for i,v in ipairs(Note) do 
        local EntryType,arg1,arg2,arg3,arg4,arg5,arg6 = _ARTG.SV.NoteEntry("Header","Unpack",v[1])
        if EntryType == "T" or arg5 then 
            v.Time = arg1
        end 
    end 
    
    for i = 1,getn(Note) do 
        if Note[i].Time then 
            local bi = i - 1
            local RefIndex = i
            while bi > 0 do 
                if Note[bi].Time and Note[RefIndex].Time < Note[bi].Time then 
                    local header,data,time = Note[RefIndex][1],Note[RefIndex][2],Note[RefIndex].Time
                    remove(Note,RefIndex)
                    insert(Note,bi,{header,data,Time = time})
                    RefIndex = bi
                end 
                bi = bi - 1
            end 
            if RefIndex == i then 
                bi = i + 1
                while bi <= getn(Note) do 
                    if Note[bi].Time and Note[RefIndex].Time > Note[bi].Time then 
                        local header,data,time = Note[RefIndex][1],Note[RefIndex][2],Note[RefIndex].Time
                        insert(Note,bi,{header,data,Time = time})
                        remove(Note,RefIndex)
                        RefIndex = bi
                    end 
                    bi = bi + 1
                end 
            end 
        end 
    end 
    
    --clean table
    for i,v in ipairs(Note) do 
        v.Time = nil
    end 
end 

local MaxFavorites = 40
_ARTG.SV.CooldownEdit = function(Action,...)
    if Action == "Create" then 
        local CDLink = ...
        insert(AvyrRaidTools_DB.EditorCooldowns.LastCreated,1,CDLink)
        if getn(AvyrRaidTools_DB.EditorCooldowns.LastCreated) > 3 then 
            remove(AvyrRaidTools_DB.EditorCooldowns.LastCreated,4)
        end
        _ARTG.Editor:UpdateFavoriteCDs()
    elseif Action == "EditFavorite" then 

    elseif Action == "RemoveFavorite" then 
        local CDLink = ...
        local CDIndex =  _ARTG.SV.CooldownEdit("IsFavorite",CDLink)
        if CDIndex then 
            remove(AvyrRaidTools_DB.EditorCooldowns.Favorites,CDIndex)
            _ARTG.Editor.UpdateAllEntryNote()
            _ARTG.Editor:UpdateFavoriteCDs()
        end 
    elseif Action == "AddFavorite" then 
        local CDLink = ...
        if not _ARTG.SV.CooldownEdit("IsFavorite",CDLink) and getn(AvyrRaidTools_DB.EditorCooldowns.Favorites) <= MaxFavorites then 
            insert(AvyrRaidTools_DB.EditorCooldowns.Favorites,1,CDLink)
            _ARTG.Editor.UpdateAllEntryNote()
            _ARTG.Editor:UpdateFavoriteCDs()
        end 
    elseif Action == "MaxFavorite" then 
        return MaxFavorites
    elseif Action == "IsFavorite" then 
        local CDLink = ...
        for i,v in ipairs(AvyrRaidTools_DB.EditorCooldowns.Favorites) do 
            if v == CDLink then 
                return i
            end 
        end 
    end 
end
