local insert, type = table.insert, type
_Avyr_Global_ADDON_Elements_Lib = _Avyr_Global_ADDON_Elements_Lib or CreateFrame("FRAME")
_Avyr_Global_ADDON_Elements_Lib.LocalisationMixin = _Avyr_Global_ADDON_Elements_Lib.LocalisationMixin or {}
_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin = _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin or {
    BorderSize = 3,
    Padding = 2,
    BackdropColor = { r = 0.1, g = 0.1, b = 0.1, a = 0.9 },
    BorderColor = { r = 0, g = 0, b = 0, a = 1 },
    HighlightColor = { r = 1, g = 0.82, b = 0, a = 1 },
    NormalColor = {r = 1,g = 1,b = 1,a = 1},   
    MediaPath = "",
}

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:GetIcon(IconName)
    return self.MediaPath..IconName..".blp"
end

_Avyr_Global_ADDON_Elements_Lib.Textures = _Avyr_Global_ADDON_Elements_Lib.Textures or {}
_Avyr_Global_ADDON_Elements_Lib.FontStrings = _Avyr_Global_ADDON_Elements_Lib.FontStrings or {}
_Avyr_Global_ADDON_Elements_Lib.TextBoxes = _Avyr_Global_ADDON_Elements_Lib.TextBoxes or {}

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:DefaultTheme()
    self:SetTheme("Backdrop",_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.BackdropColor.r,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.BackdropColor.g,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.BackdropColor.b,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.BackdropColor.a)
    self:SetTheme("Border",_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.BorderColor.r,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.BorderColor.g,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.BorderColor.b,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.BorderColor.a)
    self:SetTheme("Highlight",_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.HighlightColor.r,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.HighlightColor.g,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.HighlightColor.b,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.HighlightColor.a)
    self:SetTheme("Normal",_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.NormalColor.r,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.NormalColor.g,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.NormalColor.b,_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.NormalColor.a)
end 

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:SetTheme(Type,r,g,b,a)
    if type(Type) == "string" and (r or _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin[Type.."Color"]) and (g or _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin[Type.."Color"]) 
    and (b or _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin[Type.."Color"]) then 
        self[Type.."Color"].r = r or _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin[Type.."Color"].r or 1
        self[Type.."Color"].g = g or _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin[Type.."Color"].g or 1
        self[Type.."Color"].b = b or _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin[Type.."Color"].b or 1
        self[Type.."Color"].a = a or _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin[Type.."Color"].a or 1
        self.PrimaryMulti = self.PrimaryMulti or 1
        self.SecondaryMulti = self.SecondaryMulti or 1
        for i,v in ipairs(_Avyr_Global_ADDON_Elements_Lib.Textures) do 
            --print(self.AddonName)
            if v.ColorThemeAlignment then
                --print(v.ColorThemeAlignment)
                
                if v.ColorThemeAlignment == self.AddonName..Type and not v.SecondaryColorTheme then 
                    v:SetVertexColor(v.PrimaryMulti*self[Type.."Color"].r,v.PrimaryMulti*self[Type.."Color"].g,v.PrimaryMulti*self[Type.."Color"].b,v.PrimaryAlpha*self[Type.."Color"].a)
                elseif v.ColorThemeAlignment == self.AddonName..Type and v.SecondaryColorTheme then 
                    local SecondaryType = v.SecondaryColorTheme:gsub(self.AddonName,"",1)
                    v:SetGradientAlpha("HORIZONTAL", v.PrimaryMulti*self[Type.."Color"].r,v.PrimaryMulti*self[Type.."Color"].g,v.PrimaryMulti*self[Type.."Color"].b, v.PrimaryAlpha*self[Type.."Color"].a, 
                    v.SecondaryMulti*self[SecondaryType.."Color"].r,v.SecondaryMulti*self[SecondaryType.."Color"].g,v.SecondaryMulti*self[SecondaryType.."Color"].b, v.SecondaryAlpha*self[SecondaryType.."Color"].a)
                elseif v.SecondaryColorTheme and v.SecondaryColorTheme == self.AddonName..Type then  
                    local Primary = v.ColorThemeAlignment:gsub(self.AddonName,"",1)
                    v:SetGradientAlpha("HORIZONTAL", v.PrimaryMulti*self[Primary.."Color"].r,v.PrimaryMulti*self[Primary.."Color"].g,v.PrimaryMulti*self[Primary.."Color"].b, v.PrimaryAlpha*self[Primary.."Color"].a, 
                    v.SecondaryMulti*self[Type.."Color"].r,v.SecondaryMulti*self[Type.."Color"].g,v.SecondaryMulti*self[Type.."Color"].b, v.SecondaryAlpha*self[Type.."Color"].a)
                end 
            end 
        end 
        for i,v in ipairs(_Avyr_Global_ADDON_Elements_Lib.FontStrings) do 
            if v.ColorThemeAlignment and v.ColorThemeAlignment == self.AddonName..Type then 
                v:SetTextColor(self[Type.."Color"].r,self[Type.."Color"].g,self[Type.."Color"].b)
            end             
        end 
        for i,v in ipairs(_Avyr_Global_ADDON_Elements_Lib.TextBoxes) do 
            if v.ColorThemeAlignment and v.ColorThemeAlignment == self.AddonName..Type then 
                v:SetTextColor(self[Type.."Color"].r,self[Type.."Color"].g,self[Type.."Color"].b)
            end   
        end 
    end
end 

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:SetThemedColor(Frame,Type,SecondaryType,PrimaryMulti,SecondaryMulti,PrimaryAlpha,SecondaryAlpha)
    Frame.PrimaryMulti = PrimaryMulti or 1
    Frame.SecondaryMulti = SecondaryMulti or 1
    Frame.PrimaryAlpha = PrimaryAlpha or 1
    Frame.SecondaryAlpha = SecondaryAlpha or 1
    if type(Type) == "string" then 
        Frame.ColorThemeAlignment = self.AddonName..Type
        if Frame.SetTextColor then --font string
            Frame:SetTextColor(self[Type.."Color"].r,self[Type.."Color"].g,self[Type.."Color"].b)
        elseif Frame.SetVertexColor then --texture 
            if SecondaryType then 
                Frame.SecondaryColorTheme = self.AddonName..SecondaryType
                Frame:SetColorTexture(1, 1, 1, 1)
                Frame:SetGradientAlpha("HORIZONTAL", Frame.PrimaryMulti*self[Type.."Color"].r,Frame.PrimaryMulti*self[Type.."Color"].g,Frame.PrimaryMulti*self[Type.."Color"].b, Frame.PrimaryAlpha*self[Type.."Color"].a, 
                Frame.SecondaryMulti*self[SecondaryType.."Color"].r,Frame.SecondaryMulti*self[SecondaryType.."Color"].g,Frame.SecondaryMulti*self[SecondaryType.."Color"].b, Frame.SecondaryAlpha*self[SecondaryType.."Color"].a)
            else 
                if type(Frame:GetTexture()) == "nil" then 
                    Frame:SetColorTexture(1, 1, 1, 1)
                end 
                Frame:SetVertexColor(Frame.PrimaryMulti*self[Type.."Color"].r,Frame.PrimaryMulti*self[Type.."Color"].g,Frame.PrimaryMulti*self[Type.."Color"].b,Frame.PrimaryAlpha*self[Type.."Color"].a)
            end
        end 
    end 
end 

_Avyr_Global_ADDON_Elements_Lib.AddonPool = _Avyr_Global_ADDON_Elements_Lib.AddonPool or {}

--_Avyr_Global_ADDON_Elements_Lib.AddonPool["AvyrRaidTools"].Localisation.MissingTranslations

_Avyr_Global_ADDON_Elements_Lib.LocalisationMixin.Data = {}
_Avyr_Global_ADDON_Elements_Lib.LocalisationMixin.MissingTranslations = {}
function _Avyr_Global_ADDON_Elements_Lib.LocalisationMixin:Translation(Text)
    if type(Text) == "string" then 
        if self.Data[Text] then 
            local Lang = GetLocale()
            if Lang == "enGB" then 
                Lang  = "enUS"
            end
			if self.Data[Text][Lang] then 
                return self.Data[Text][Lang]
            else 
                insert(self.MissingTranslations,Text)
                return Text
            end 
        else 
            insert(self.MissingTranslations,Text)
            return Text
        end 
    end 
end 

function _Avyr_Global_ADDON_Elements_Lib:Mixin(Origin,Target)
    for i,v in pairs(Origin) do 
        if type(v) == "table" then 
            Target[i] = {}
            _Avyr_Global_ADDON_Elements_Lib:Mixin(v,Target[i])
        else 
            Target[i] = v
        end 
    end 
end

function _Avyr_Global_ADDON_Elements_Lib:Initialize(AddonName,Type) 
    if not _Avyr_Global_ADDON_Elements_Lib.AddonPool[AddonName] then 
        _Avyr_Global_ADDON_Elements_Lib.AddonPool[AddonName] = {
            Widgets = {},
            Localisation = {},
        }
        _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.AddonName = AddonName
        _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.MediaPath = "Interface\\Addons\\"..AddonName.."\\Widgets\\Media\\"

        _Avyr_Global_ADDON_Elements_Lib:Mixin(_Avyr_Global_ADDON_Elements_Lib.WidgetsMixin,_Avyr_Global_ADDON_Elements_Lib.AddonPool[AddonName].Widgets)
        _Avyr_Global_ADDON_Elements_Lib:Mixin(_Avyr_Global_ADDON_Elements_Lib.LocalisationMixin,_Avyr_Global_ADDON_Elements_Lib.AddonPool[AddonName].Localisation)
        
        _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin.AddonName = "No_Addon"
    end

    if Type == "Widgets" then 
        return _Avyr_Global_ADDON_Elements_Lib.AddonPool[AddonName].Widgets 
    elseif Type == "Localisation" then 
        return _Avyr_Global_ADDON_Elements_Lib.AddonPool[AddonName].Localisation 
    end 
end 

